Package: LegATo
Title: LegATo: Longitudinal mEtaGenomic Analysis Toolkit
Version: 1.5.0
Authors@R: c(
    person("Aubrey", "Odom", , "aodom@bu.edu", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0001-7113-7598")),
    person("Yilong", "Zhang", , "elong0527@gmail.com", role = "ctb",
           comment = "Author of NMIT functions"),
    person("Jared", "Pincus", , "pincus@bu.edu", role = "csl",
           comment = c(ORCID = "0000-0001-6708-5262", other = "Naming consultant of package")),
    person("Jordan", "Pincus", , "pincus@bu.edu", role = "art",
           comment = "Artist of LegATo icon")
  )
Description: LegATo is a suite of open-source software tools for
    longitudinal microbiome analysis. It is extendable to several
    different study forms with optimal ease-of-use for researchers.
    Microbiome time-series data presents distinct challenges including
    complex covariate dependencies and variety of longitudinal study
    designs. This toolkit will allow researchers to determine which
    microbial taxa are affected over time by perturbations such as onset
    of disease or lifestyle choices, and to predict the effects of these
    perturbations over time, including changes in composition or stability
    of commensal bacteria.
License: MIT + file LICENSE
URL: https://wejlab.github.io/LegATo-docs/
BugReports: https://github.com/wejlab/LegATo/issues
Depends: R (>= 4.4.0)
Imports: animalcules, data.table, dplyr, ggplot2, magrittr,
        MultiAssayExperiment, plyr, rlang, S4Vectors, stringr,
        SummarizedExperiment, tibble, tidyr, tidyselect
Suggests: BiocStyle, broom, broom.mixed, circlize, ComplexHeatmap,
        emmeans, geepack, ggalluvial, ggeffects, grDevices, knitr,
        lme4, lmerTest, methods, RColorBrewer, rmarkdown, spelling,
        TBSignatureProfiler, testthat (>= 3.0.0),
        TreeSummarizedExperiment, usethis, vegan
VignetteBuilder: knitr
BiocType: Software
biocViews: MicrobiomeData, ReproducibleResearch, SequencingData
Config/testthat/edition: 3
Encoding: UTF-8
Language: en-US
RoxygenNote: 7.3.2
git_url: https://git.bioconductor.org/packages/LegATo
git_branch: devel
git_last_commit: e6be75b
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-11-04
NeedsCompilation: no
Packaged: 2025-11-04 16:29:07 UTC; biocbuild
Author: Aubrey Odom [aut, cre] (ORCID: <https://orcid.org/0000-0001-7113-7598>),
  Yilong Zhang [ctb] (Author of NMIT functions),
  Jared Pincus [csl] (ORCID: <https://orcid.org/0000-0001-6708-5262>,
    other: Naming consultant of package),
  Jordan Pincus [art] (Artist of LegATo icon)
Maintainer: Aubrey Odom <aodom@bu.edu>

# LegATo
### A Longitudinal mEtaGenomic Analysis Toolkit <img src="https://github.com/wejlab/Legato-docs/blob/main/legato-logo.jpg?raw=true" align="right" width="140">

LegATo is a suite of open-source software tools for longitudinal microbiome analysis. It is extendable to
several different study forms with optimal ease-of-use for researchers. Microbiome time-series data
presents distinct challenges including complex covariate dependencies and variety of longitudinal study
designs. This toolkit will allow researchers to determine which microbial taxa are affected over time by
perturbations such as onset of disease or lifestyle choices, and to predict the effects of these perturbations
over time, including changes in composition or stability of commensal bacteria. 

LegATo integrates visualization, modeling and testing procedures. It is currently in development, but it will soon be supplemented by hierarchical clustering tools and multivariate generalized estimating equations (JGEEs) to adjust for the compositional nature of microbiome data.

### The Story Behind the Name
In music, legato indicates that notes are played or sung smoothly and connected over time, without a noticeable break between them. 

The LegATo package facilitates a cohesive and interconnected understanding of longitudinally-collected sequencing samples, much like the smooth connection of musical notes in a legato passage. 

## Documentation
Documentation and tutorials for LegATo are available at our [website](https://wejlab.github.io/LegATo-docs/).

Check out a thorough tutorial on proper usage of our package [here](https://wejlab.github.io/LegATo-docs/articles/LegATo_vignette.html).

## Installation
LegATo requires R Version 4.3.

Install the development version of the package from Github:

```
BiocManager::install("wejlab/LegATo")
```

utils::globalVariables(".")

#' Filter a MultiAssayExperiment to a top percentage of taxa and label the rest
#' as "Other"
#'
#' This function takes an animalcules-formatted \code{MultiAssayExperiment}
#' (MAE) object and identifies all taxa at the "genus" level that represent
#' <\code{filter_prop} average relative abundance across all samples in the MAE.
#' After identification at the genus level, taxa across the genus and species
#' levels are then consolidated into the category "Other".
#'
#' @inheritParams plot_stacked_bar
#' @param filter_prop A double strictly between 0 and 1, representing
#' the proportion of relative abundance at which to filter. Default is 0.001.
#'
#' @returns An animalcules-formatted \code{MultiAssayExperiment} object with
#'   appropriate filtration.
#'
#' @export
#' @importFrom rlang .data
#'
#' @examples
#' in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
#' filter_animalcules_MAE(in_dat, 0.01)
#' 

filter_animalcules_MAE <- function(dat, filter_prop = 0.001) {
    if(filter_prop <= 0 | filter_prop >= 1) stop("filter_prop must be between 0 and 1.")
    # Extract metadata, taxonomic info, and counts
    parsed <- parse_MAE_SE(dat, which_experiment = "MicrobeGenetics",
                           which_assay = "MGX", type = "MAE")
    tax_table <- parsed$tax
    sam_table <- parsed$sam
    counts_table <- parsed$counts
    
    all_relabu_genus <- counts_table %>%
        as.matrix() %>%
        # Get rel abu within samples
        prop.table(margin = 2) %>%
        tibble::as_tibble() %>%
        dplyr::bind_cols("genus" = tax_table$genus) %>%
        dplyr::relocate("genus") %>%
        dplyr::group_by(.data$genus) %>%
        # Sum rel abu within samples/columns for genera
        dplyr::summarise(dplyr::across(.fns = sum, .cols = dplyr::everything())) %>%
        # Sum everything but the first columm ("genus")
        dplyr::mutate("allmeans" = rowMeans(dplyr::select(., -1))) %>%
        dplyr::select("genus", "allmeans") %>%
        dplyr::mutate("genus" = replace(.data$genus, is.na(.data$genus), "Unknown")) %>%
        dplyr::arrange(dplyr::desc(.data$allmeans)) %>%
        dplyr::mutate("lessthanXpct" = .data$allmeans < filter_prop)
    
    # Identify species in other
    othergenera <- all_relabu_genus %>%
        dplyr::filter(.data$lessthanXpct == TRUE) %>%
        dplyr::select("genus") %>% unlist() %>% unname()
    
    ## Use the identified species to update the tax, species tables
    
    # Replace tax table
    tax_table_other <- tax_table %>%
        dplyr::mutate("genus" = replace(.data$genus, is.na(.data$genus), "Unknown")) %>%
        dplyr::mutate(dplyr::across(c(.data$genus, .data$species),
                                    function(x) replace(x, .data$genus %in% othergenera, "Other")))
    
    # Resum the counts table
    counts_other <- counts_table %>%
        dplyr::bind_cols("species" = tax_table_other$species) %>%
        dplyr::group_by(.data$species) %>%
        dplyr::summarise(dplyr::across(.cols = dplyr::all_of(colnames(counts_table)),
                                       .fns = sum)) %>%
        tibble::column_to_rownames("species")
    
    # Adjust tax table accordingly
    tax_table_other2 <- tax_table_other %>%
        dplyr::distinct(.data$species, .keep_all = TRUE) %>%
        dplyr::arrange(.data$species)
    
    rownames(tax_table_other2) <- tax_table_other2$species
    
    ## Create SE object
    MAE_out <- create_formatted_MAE(counts_other, tax_table_other2, sam_table)
    return(MAE_out)
}

# Helper function to rearrange MAE by unit, then time
.rearrange_sub_time <- function(dat, unit_var, covariate_time) {
  all_dat <- parse_MAE_SE(dat)
  map <- all_dat$sam
  otu <- all_dat$counts
  tax <- all_dat$tax
  map2 <- map |>
    dplyr::arrange(!!! rlang::syms(c(unit_var, covariate_time)))
  ind <- match(rownames(map2), colnames(otu))
  otu2 <- otu[, ind]
  MAE <- create_formatted_MAE(otu2, tax, map2)
  return(MAE)
}

# Helper function for if standard deviation is 0 during stats::cor
safe_cor <- function(x, y = NULL, method = "pearson") {
    df <- x[, colSums(x) != 0]
    tryCatch({
        # Try to compute the correlation
        result <- stats::cor(x = df, y, method = method)
        return(result)
    }, error = function(e) {
        # If an error occurs (like zero standard deviation), return NA or a custom message
        if (grepl("the standard deviation is zero", e$message)) {
            return(NA)
        } else {
            # Return the error message if it's another issue
            stop(e)
        }
    })
}

#' Calculate within-subject OTU correlations
#'
#' This function takes a \code{MultiAssayExperiment} and outputs an array of
#' temporal intra-subject correlation matrices.
#'
#' @author Yilong Zhang, Huilin Li, Aubrey Odom
#'
#' @inheritParams clean_MAE
#' @param method an option of the correlation method ("pearson", "kendall",
#'   "spearman"). The default method is "kendall".
#' @param unit_var a numeric vector of subject.
#' @param fill_na a number between 0 and 1 to fill the missing value. The
#'   default value is 0.
#'
#' @return An three-dimensional array of temporal correlation matrices for each
#'   subject.
#' @export
#' @examples
#' dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
#' output <- tscor(dat, unit_var = "Subject", method = "spearman")
#' head(output)
#' 

tscor <- function(dat, unit_var, method = "kendall", fill_na = 0) {
  if (!(method %in% c("pearson","kendall","spearman"))) {
    stop("method must be one of 'pearson', 'kendall', 'spearman'")
  }
  all_dat <- parse_MAE_SE(dat)
  map <- all_dat$sam
  otus <- all_dat$counts |> t() |> as.data.frame()
  d <- ncol(otus)
  
  # Split OTU tables by unit_var
  sub_split <- map |> dplyr::pull(dplyr::all_of(unit_var))
  otu_list <- split(otus, sub_split)
  
  # Pairwise correlations for each OTU sub-table
  cor_list <- lapply(otu_list, safe_cor, method = method)
  
  names.cor <- names(cor_list)
  names.otu <- colnames(otus)
  
  # Collect correlations into multidimensional array
  cor_unlist <- unlist(cor_list)
  cor_unlist[is.na(cor_unlist)] <- fill_na
  cor_arr <- array(cor_unlist,
                   dim = c(d, d, length(cor_list)),
                   dimnames = list(names.otu, names.otu, names.cor))
  return(cor_arr)
}

#' Nonparametric Microbial Interdependence Test (NMIT)
#'
#' An R-based implementation of the NMIT, a multivariate distance-based test for
#' group comparisons of microbial temporal interdependence. The NMIT test
#' provides a comprehensive way to evaluate the association between key
#' phenotypic variables and microbial interdependence. This function is
#' recommended for use after a filtering step using
#' \code{filter_MAE}. Note, the "ComplexHeatmap" package is required to
#' use the plotting features of the function. The function requires the
#' "vegan" package.
#'
#' @author Yilong Zhang, Huilin Li, Aubrey Odom
#'
#' @inheritParams tscor
#' @inheritParams plot_stacked_bar
#' @param fixed_cov A character vector of the names of covariates of interest found in
#'   \code{dat}.
#' @param dist_type A character string specifying the type of matrix norm to be
#'   computed. The default is \code{"F"}.
#'   * \code{"M"} or \code{"m"} specifies the maximum modulus of all the
#'     elements in \code{x};
#'   * \code{"O"}, \code{"o"} or \code{"1"} specifies the one norm,
#'     (maximum absolute column sum);
#'   * \code{"I"} or \code{"i"} specifies the infinity norm (maximum
#'     absolute row sum);
#'   * \code{"F"} or \code{"f"} specifies the Frobenius norm (the
#'     Euclidean norm of \code{x} treated as if it were a vector)
#' @param heatmap A logical value indicating whether to draw heatmap. The
#'   default is \code{TRUE}.
#' @param classify A logical value indicating whether to draw a classifier tree.
#'   The default is \code{FALSE}.
#' @param fill_na A number between 0 and 1 to fill \code{NA} values. The default
#'   value is 0.
#' @param ... Additional arguments to be passed to \code{ComplexHeatmap::Heatmap()}.
#'
#' @return This function returns an analysis of variance (ANOVA) table showing
#'   sources of variation, degrees of freedom, sequential sums of squares, mean
#'   squares, F statistics, partial R-squared and P values, based on 999
#'   permutations.
#'
#' @export
#' 
#' @examples
#' dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
#' NMIT(dat, unit_var = "Subject", fixed_cov = "Group", covariate_time = "Month")
#' 

NMIT <- function(dat, unit_var, fixed_cov,
                 covariate_time,
                 method = "kendall", dist_type = "F",
                 heatmap = TRUE, classify = FALSE,
                 fill_na = 0,
                 ...) {
  # Ensure that vegan is installed
  if (!requireNamespace("vegan", quietly = TRUE)) {
    message("The 'vegan' package is not installed",
            "Please install it from CRAN to use this function.")
  }
  dat <- .rearrange_sub_time(dat, unit_var, covariate_time) 
  all_dat <- parse_MAE_SE(dat)
  map <- all_dat$sam
  otu <- all_dat$counts
  map.unique <- unique(map[, c(unit_var, fixed_cov)])
  rownames(map.unique) <- map.unique[, unit_var]
  n.sample <- length(unique(map[, unit_var]))
  otu.cor <- tscor(dat, method = method,
                   unit_var = unit_var, fill_na = fill_na) # |>
    # suppressWarnings()
  dist <- outer(seq_len(n.sample), seq_len(n.sample),
                function(x,y) {
                  foo <- function(x,y) norm(otu.cor[, , x] - otu.cor[, , y],
                                            type = dist_type)
                  mapply(foo, x,y)
                })
  rownames(dist) <- dimnames(otu.cor)[[3]]
  colnames(dist) <- dimnames(otu.cor)[[3]]
  if (length(fixed_cov) > 1) {
    grp <- map.unique[rownames(dist), fixed_cov]
  } else {
    grp <- map.unique[rownames(dist), fixed_cov] %>%
      as.data.frame() %>% magrittr::set_colnames(fixed_cov)
  }
  adonis_formula <- stats::as.formula(paste("dist ~", paste(names(grp), collapse = " + ")))
  test <- vegan::adonis2(adonis_formula, data = grp)
  if(heatmap){
    # Ensure that ComplexHeatmap is installed
    if (!requireNamespace("ComplexHeatmap", quietly = TRUE)) {
      message("The 'ComplexHeatmap' package is not installed",
              "Please install it from CRAN to use this function.")
    }
    pvalue <- round(c(test$`Pr(>F)`[1]), 3)
    n.taxa <- nrow(otu)
    
    diag(dist) <- stats::median(dist)
    mat <- as.matrix(sqrt(dist))
    
    plot_title <- paste0(" # OTU: ", n.taxa, " pvalue: ", pvalue)
    cov_mat <- grp %>% as.matrix %>%
      magrittr::set_rownames(rownames(dist)) %>%
      magrittr::set_colnames(fixed_cov) %>%
      as.data.frame
    plot_heatmap(
      inputData = mat,
      annotationData = cov_mat,
      name = "NMIT Correlation",
      plot_title = plot_title,
      plottingColNames = NULL,
      annotationColNames = NULL,
      colList = list(),
      scale = FALSE,
      showColumnNames = TRUE,
      showRowNames = TRUE,
      colorSets = c("Set1", "Set2", "Set3", "Pastel1", "Pastel2", "Accent", "Dark2",
                    "Paired"),
      choose_color = c("blue", "gray95", "red"),
      split_heatmap = "none",
      column_order = NULL,
      ...
    )
  }
}

testthat::test_that("plot_alluvial works", {
    in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
    testthat::expect_s3_class(
        plot_alluvial(
            in_dat,
            taxon_level = "family",
            covariate_1 = "Group",
            covariate_time = "Month",
            palette_input = rainbow(25)
        ),
        "ggplot"
    )
    
})

testthat::test_that("plot_spaghetti works", {
    in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
    all_taxa <- get_top_taxa(in_dat, "phylum")
    
    testthat::expect_s3_class(
        plot_spaghetti(
            in_dat,
            taxon_level = "phylum",
            covariate_1 = "Group",
            covariate_time = "Month",
            unit_var = "Subject",
            which_taxon = all_taxa$taxon[1],
            palette_input = rainbow(25)
        ),
        "ggplot"
    )
    
})

testthat::test_that("plot_stacked_area works", {
    in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
    
    testthat::expect_s3_class(
        plot_stacked_area(
            in_dat,
            taxon_level = "phylum",
            covariate_1 = "Group",
            covariate_time = "Month",
            palette_input = rainbow(25)
        ),
        "ggplot"
    )
})

testthat::test_that("plot_stacked_bar works", {
    in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
    
    testthat::expect_s3_class(
        plot_stacked_bar(
            in_dat,
            taxon_level = "family",
            covariate_1 = "Group",
            covariate_time = "Month",
            palette_input = rainbow(25)
        ),
        "ggplot"
    )
})

testthat::test_that("plot_heatmap works", {
    mat_testdata <- rbind(matrix(c(rnorm(80), rnorm(80) + 5), 16, 10, dimnames = list(
        paste0("Taxon", seq_len(16)), paste0("sample", seq_len(10))
    )),
    matrix(rnorm(1000), 100, 10, dimnames = list(
        paste0("Taxon0", seq_len(100)), paste0("sample", seq_len(10))
    )))
    cov_mat <- data.frame(sample = c(rep("down", 5), rep("up", 5))) |>
        magrittr::set_rownames(paste0("sample", seq_len(10)))
    
    # Example using custom colors for the annotation information
    color2 <- stats::setNames(c("purple", "black"), c("down", "up"))
    color.list <- list("sample" = color2)
    
    testthat::expect_type(
        plot_heatmap(
            inputData = mat_testdata,
            annotationData = cov_mat,
            name = "Data",
            plot_title = "Example",
            plottingColNames = NULL,
            annotationColNames = NULL,
            colList = color.list,
            scale = FALSE,
            showColumnNames = TRUE,
            showRowNames = FALSE,
            colorSets = c(
                "Set1",
                "Set2",
                "Set3",
                "Pastel1",
                "Pastel2",
                "Accent",
                "Dark2",
                "Paired"
            ),
            choose_color = c("blue", "gray95", "red"),
            split_heatmap = "none",
            column_order = NULL
        ),
        "NULL"
    )
})

testthat::test_that("distinctColors works", {
    testthat::expect_vector(distinctColors(10))
})

testthat::test_that("run_gee_model works", {
    in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |>
        readRDS()
    testthat::expect_s3_class(
        run_gee_model(
            in_dat,
            taxon_level = "genus",
            unit_var = "Subject",
            fixed_cov = c("HairLength", "Age", "Group", "Sex"),
            corstr = "ar1"
        ),
        "data.frame"
    )
})

testthat::test_that("filter_animalcules_MAE works", {
    in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
    
    
    testthat::expect_s4_class(filter_animalcules_MAE(in_dat, 0.01),
                              "MultiAssayExperiment")
})

testthat::test_that("run_lmm_model works", {
   dat <- system.file("extdata/MAE.RDS", package = "LegATo") |>
       readRDS() |>
       filter_animalcules_MAE(0.05)
   testthat::expect_s3_class(run_lmm_model(
       dat,
       taxon_level = "genus",
       unit_var = "Subject",
       fixed_cov = c("HIVStatus", "timepoint")
   ), "data.frame")
})

testthat::test_that(
    "run_lm_model works",
    {
        dat <- system.file("extdata/MAE.RDS", package = "LegATo") |>
            readRDS() |>
            filter_MAE(0.05)
        testthat::expect_s3_class(run_lm_model(
            dat,
            fixed_cov = c("timepoint", "HIVStatus"),
            plot_out = FALSE
        ),
        "data.frame")
})

testthat::test_that("test_hotelling_t2 works", {
    dat <- system.file("extdata", "MAE.RDS", package = "LegATo") |>
        readRDS()
    dat_0.05 <- filter_MAE(dat, 0.05)
    
    testthat::expect_type(
        test_hotelling_t2(
            dat = dat_0.05,
            test_index = which(dat_0.05$MothChild == "Infant" &
                                   dat_0.05$timepoint == 6),
            taxon_level = "genus",
            # To avoid n < p, use top 5-6 species
            num_taxa = 6,
            paired = TRUE,
            grouping_var = "HIVStatus",
            pairing_var = "pairing"
        ),
        "list"
    )
    testthat::expect_type(
        test_hotelling_t2(
            dat = dat_0.05,
            test_index = which(dat_0.05$MothChild == "Mother" &
                                   dat_0.05$timepoint == 6),
            taxon_level = "genus",
            # To avoid n < p, use top 5-6 species
            num_taxa = 6,
            paired = FALSE,
            unit_var = "Subject",
            grouping_var = "HIVStatus"
        ),
        "list"
    )
})

testthat::test_that("NMIT works", {
    dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
    testthat::expect_type(NMIT(
        dat,
        unit_var = "Subject",
        fixed_cov = "Group",
        covariate_time = "Month"
    ), "NULL")
})

 testthat::test_that("tscor works", {
     dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |>
         readRDS() |>
         filter_animalcules_MAE(0.05)
     testthat::expect_type(tscor(dat, unit_var = "Subject",
                                 method = "spearman", fill_na = 0.0004), "double")
 })

testthat::test_that("create_formatted_MAE works", {
    nsample <- ntaxa <- 3
    counts_dat <- data.frame(
        "X123" = runif(ntaxa, 0, 500),
        "X456" = runif(ntaxa, 0, 500),
        "X789" = runif(ntaxa, 0, 500)
    )
    tax_dat <- data.frame(
        "class" = c("rand1", "rand2", "rand3"),
        "species" = c("rand4", "rand5", "rand6")
    ) |>
        as.data.frame()
    # Set rownames as lowest unique taxonomic level
    rownames(tax_dat) <- tax_dat$species
    rownames(counts_dat) <- tax_dat$species
    metadata <- data.frame(
        Sample = c("X123", "X456", "X789"),
        Group = c("A", "B", "A"),
        Var = rnorm(nsample)
    )
    rownames(metadata) <- metadata$Sample
    testthat::expect_s4_class(create_formatted_MAE(counts_dat, tax_dat, metadata),
                              "MultiAssayExperiment")
    # TreeSummarizedExperiment
    tse <- TreeSummarizedExperiment::TreeSummarizedExperiment(
        assays = list(counts = counts_dat),
        colData = metadata,            
        rowData = tax_dat             
    )
    testthat::expect_s4_class(create_formatted_MAE(tree_SE = tse),
                              "MultiAssayExperiment")
})

testthat::test_that("clean_MAE works", {
    in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
    
    
    testthat::expect_s4_class(clean_MAE(in_dat), "MultiAssayExperiment")
})

testthat::test_that("filter_MAE works", {
    in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
    
    testthat::expect_s4_class(filter_MAE(in_dat, 0.01), "MultiAssayExperiment")
})

testthat::test_that("parse_MAE_SE works", {
    in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
    testthat::expect_type(parse_MAE_SE(in_dat), "list")
})

testthat::test_that("get_long_data works", {
    in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
    testthat::expect_s3_class(get_long_data(in_dat, "genus", log = TRUE, counts_to_CPM = TRUE),
                              "data.frame")
})

testthat::test_that("get_stacked_data works", {
    in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
    
    testthat::expect_s3_class(
        get_stacked_data(
            in_dat,
            "genus",
            covariate_1 = "Sex",
            covariate_time = "Month"
        ),
        "data.frame"
    )
    testthat::expect_s3_class(
        get_stacked_data(
            in_dat,
            "genus",
            covariate_1 = NULL,
            covariate_time = "Month"
        ),
        "data.frame"
    )
})

testthat::test_that("get_summary_table works", {
    in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
    testthat::expect_s3_class(get_summary_table(in_dat, c("Group", "Subject")), "data.frame")
})

testthat::test_that("get_top_taxa works", {
    in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
    testthat::expect_s3_class(get_top_taxa(in_dat, "genus"), "data.frame")
})

test_models_lmm <- function(tn, input_df, unit_var, fixed_cov,
                            plotsave_loc, plot_terms, plot_out, ...) {
  filt_df <- input_df %>% 
    dplyr::mutate("unit_var" = as.factor(input_df[, unit_var])) %>%
    dplyr::filter(.data$taxon == tn) %>%
    dplyr::arrange(.data$unit_var)
  group_vars <- paste("Abundance ~", paste(fixed_cov, collapse = " + ")) %>%
    paste0(" + (1|", unit_var, ")") %>%
    stats::formula()
  if (!requireNamespace("lmerTest", quietly = TRUE)) {
    message("The 'lmerTest' package is not installed",
            "Please install it from CRAN to use this function.")
  }
  complex <- lmerTest::lmer(group_vars, data = filt_df,
                        na.action = stats::na.omit)
  if (requireNamespace("broom", quietly = TRUE) &&
      requireNamespace("broom.mixed", quietly = TRUE)) {
    sum_comp <- broom.mixed::tidy(complex) %>%
      dplyr::filter(is.na(.data$group)) %>%
      dplyr::select(-"group")
  } else {
    message("The 'broom' and/or 'broom.mixed' packages are not installed",
            "Please install them to use this function.")
  }
  
  if (plot_out) {
    plyr::a_ply(fixed_cov, 1, mk_gee_plot, complex = complex, tn = tn,
                plotsave_loc = plotsave_loc, plot_terms = plot_terms, ...)
  }
  res_out <- sum_comp %>%
    dplyr::mutate("Taxon" = tn) %>%
    dplyr::rename("Coefficient" = "term",
                  "Coefficient Estimate" = "estimate",
    #              "Lower 95% CI" = "2.5 %",
    #              "Upper 95% CI" = "97.5 %",
                  "Standard Error" = "std.error",
                  "Statistic" = "statistic",
                  "Unadj p-value" = "p.value") %>%
    as.data.frame()
  return(res_out)
}


#' Compute linear mixed-effects models (LMM) on longitudinal microbiome data
#'
#' This function takes an animalcules-formatted \code{MultiAssayExperiment} and
#' runs an independent LMM model for each taxon. The model predicts taxon log
#' CPM abundance as a product of fixed-effects covariates with a random effect,
#' usually the unit on which repeated measurements were taken. Note, the 'broom',
#' 'lmerTest', and 'broom.mixed' packages are required to use this function; they can
#' be downloaded from CRAN.
#'
#' P-values are adjusted for the model coefficients within each taxon. The
#' following methods are permitted: \code{c("holm", "hochberg", "hommel",
#' "bonferroni", "BH", "BY", "fdr", "none")}
#' 
#' 
#'
#' @inheritParams run_gee_model
#'
#' @export
#' @importFrom rlang .data
#'
#' @returns A \code{data.frame} of modeling results.
#' @examples
#' dat <- system.file("extdata/MAE.RDS", package = "LegATo") |>
#'   readRDS() |>
#'   filter_MAE()
#' out <- run_lmm_model(dat, taxon_level = "genus", unit_var = "Subject",
#'                      fixed_cov = c("HIVStatus", "timepoint"))
#' head(out)
#'

run_lmm_model <- function(dat,
                          taxon_level = "genus",
                          unit_var,
                          fixed_cov,
                          p_adj_method = "fdr",
                          plot_out = FALSE,
                          plotsave_loc = ".",
                          plot_terms = NULL,
                          ...) {
  input_df <- get_long_data(dat, taxon_level, log = TRUE, counts_to_CPM = TRUE)
  all_tn <- get_top_taxa(dat, taxon_level) %>% dplyr::pull("taxon")
  n <- length(all_tn)
  storage <- plyr::llply(all_tn, test_models_lmm, input_df = input_df,
                         fixed_cov = fixed_cov,
                         unit_var = unit_var,
                         plot_out = plot_out,
                         plotsave_loc = plotsave_loc,
                         plot_terms = plot_terms,
                         ...) %>%
    data.table::rbindlist() %>%
    dplyr::arrange(.data$Coefficient) %>%
    dplyr::group_by(.data$Coefficient) %>%
    dplyr::mutate("Adj p-value" = stats::p.adjust(
      .data$`Unadj p-value`, method = p_adj_method)) %>%
    as.data.frame()
  return(storage)
}

#' Plot a stacked area chart of microbial relative abundance
#'
#' This function takes a \code{MultiAssayExperiment} object and returns a
#' stacked area chart of microbe relative abundances. The function takes a single
#' covariate as an optional variable by which to create a grid of multiple
#' plots.
#'
#' If further manipulation of specific parameters is desired, users can add
#' \code{ggplot2} function calls to the output of the function.
#'
#' @inheritParams plot_stacked_bar
#'
#' @return A \code{ggplot2} plot.
#'
#' @export
#' @importFrom rlang .data
#'
#' @examples
#' in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
#' plot_stacked_area(in_dat, taxon_level = "phylum", covariate_1 = "Group",
#'                   covariate_time = "Month",
#'                   palette_input = rainbow(25))
#'

plot_stacked_area <- function(dat,
                              taxon_level,
                              covariate_1 = NULL,
                              covariate_time,
                              palette_input = NULL,
                              title = paste("Relative abundance at", taxon_level, "level"),
                              subtitle = NULL) {
  
  relabu_table <- get_stacked_data(dat, taxon_level,
                                   covariate_1, covariate_time)
  
  taxa_ordered <- get_top_taxa(dat, taxon_level) %>%
    dplyr::pull(.data$taxon)
  
  p <- relabu_table %>%
    dplyr::mutate("Taxon" = factor(.data$taxon, levels = taxa_ordered),
                  "Time point" = .data$covariate_t) %>%
    dplyr::rename("Relative abundance" = .data$value) %>%
    ggplot2::ggplot(ggplot2::aes(x = .data$`Time point`,
                                 y = .data$`Relative abundance`,
                                 fill = .data$`Taxon`)) + 
    ggplot2::geom_area(alpha = 0.7, linewidth = .2, colour = "white") +
    ggplot2::theme_classic() +
    ggplot2::labs(x = "Time point", y = "Relative abundance",
                  title = title,
                  subtitle = subtitle) +
    ggplot2::theme(legend.position = "bottom",
                   legend.title = ggplot2::element_blank())
  
  if(!is.null(covariate_1)) {
    p <- p + ggplot2::facet_grid(rows = ggplot2::vars(covariate_1))
  } 
  if (!is.null(palette_input)) {
    p <- p + ggplot2::scale_fill_manual(values = palette_input)
  }
  return(p)
}

# Helper function: unpaired multivariate Hotelling's t-squared

.Hotelling_mv_T2_un <- function(input_data, Populations, Subjects,
                                taxon = "taxon", save_table_loc, num_taxa) {
  # Rename groups
  input_data <- input_data %>%
    dplyr::select("Populations" = dplyr::starts_with(Populations),
                  "Subjects" = dplyr::starts_with(Subjects),
                  "Taxon" = dplyr::starts_with(taxon),
                  "Abundance")
  # Check that there is only one observation per group.
  nonuniq_obs <- input_data %>%
    dplyr::group_by(.data$Populations, .data$Subjects, .data$Taxon) %>%
    dplyr::summarize("count" = dplyr::n(), .groups = "drop") %>%
    dplyr::filter(.data$count > 1) %>%
    nrow()
  if(nonuniq_obs > 0) message("More than one observation per unit/group detected") 
  # Back to groups
  Group1 <- unique(input_data$Populations)[1]
  Group2 <- unique(input_data$Populations)[2]
  Sub1 <- input_data %>% dplyr::filter(.data$Populations == Group1) %>% 
    dplyr::distinct(.data$Subjects) %>% dplyr::ungroup() %>% 
    dplyr::select("Subjects") %>% unlist()
  Sub2 <- input_data %>% dplyr::filter(.data$Populations == Group2) %>% 
    dplyr::distinct(.data$Subjects) %>% dplyr::ungroup() %>%
    dplyr::select("Subjects") %>% unlist()
  # Define n
  n <- input_data %>% dplyr::group_by(Populations) %>%
    dplyr::distinct(Subjects) %>% dplyr::summarize("n_col" = dplyr::n())
  n1 <- n %>% dplyr::filter(Populations == Group1) %>%
    dplyr::select("n_col") %>% as.numeric()
  n2 <- n %>% dplyr::filter(Populations == Group2) %>%
    dplyr::select("n_col") %>% as.numeric()
  p <- length(unique(input_data$Taxon))
  # Check that it won't be singular
  # (n1 + n2 - num_taxa - 1) < 1
  num_taxa_min <- n1 + n2 - 2
  if (num_taxa > num_taxa_min) stop("num_taxa must be no larger than ", num_taxa_min)
  # Sample mean vector
  X_i <- input_data %>%
    dplyr::rename("Xi" = "Abundance")
  Xbar <- X_i %>%
    dplyr::group_by(.data$Populations, .data$Taxon) %>%
    dplyr::reframe(Xbar = mean(.data$Xi))
  # X_i - Xbar
  diff <- X_i %>%
    dplyr::left_join(Xbar, by = c("Populations", "Taxon")) %>%
    dplyr::group_by(.data$Subjects, .data$Taxon) %>%
    dplyr::reframe("diff" = .data$Xi - .data$Xbar)
  # (X_ij-Xbar_i)%*%(X_ij-Xbar_i)'
  mult_func <- function(x) {
    vec <- t(t(diff$diff[diff$Subjects == x]))
    vec %*% t(vec)
  }
  # Calculate S_p
  # Sample Var-cov matrix of vecs Y_i
  S_1 <- 1/(n1 - 1) * base::Reduce("+", lapply(Sub1, mult_func))
  S_2 <- 1/(n2 - 1) * base::Reduce("+", lapply(Sub2, mult_func))
  S_p <- ((n1 - 1) * S_1 + (n2 - 1) * S_2) / (n1 + n2 - 2)
  
  # T^2 = t(Xbar_1-Xbar_2) %*% {S_p(1/n1 + 1/n2)}^-1 %*% (Xbar_1-Xbar_2)
  Xbar_1 <- Xbar %>% dplyr::filter(.data$Populations == Group1) %>% dplyr::select("Xbar")
  Xbar_2 <- Xbar %>% dplyr::filter(.data$Populations == Group2) %>% dplyr::select("Xbar")
  meandiff <- t(t(Xbar_1 - Xbar_2))
  T_2 <- t(meandiff) %*% solve(S_p * (1 / n1 + 1 / n2)) %*% meandiff
  
  #F statistic
  # Dist according to F_p, n1 + n2 - p - 1
  F_stat <- (n1 + n2 - p - 1) / (p * (n1 + n2 - 2)) * T_2
  # Reject H0 at alpha if F-val exceeds
  df1 <- p
  df2 <- n1 + n2 - p - 1
  crit_F <- stats::qf(0.95, df1, df2)
  pval <- 1 - stats::pf(c(F_stat), df1, df2)
  
  if(pval < 0.05) {
    ttest_unpaired <- function(tax) {
      for_testing <- input_data %>% dplyr::filter(.data$Taxon == tax)
      out_test <- stats::t.test(stats::formula("Abundance ~ Populations"), for_testing,
                                alternative = "two.sided",
                                var.equal = FALSE)
      return(list(t = out_test$statistic, df = out_test$parameter,
                  diff_means = out_test$estimate[1],
                  CI_2.5 = out_test$conf.int[1],
                  CI_97.5 = out_test$conf.int[2],
                  "p-value" = out_test$p.value))
    }
    results <- plyr::aaply(unique(input_data$Taxon), 1, ttest_unpaired)
    results <- rbind(results,
                     "adj p-value" = stats::p.adjust(results["p-value", ],
                                                     method = "bonferroni"))
    # Write results
    filename_out <- paste0("ttest_results", Group1, Group2, ".csv")
    utils::write.csv(results, file.path(save_table_loc, filename_out))
    message("Results from t-tests written to", filename_out)
  }
  
  list("df1" = df1, "df2" = df2, "crit_F" = crit_F,
       "F_stat" = F_stat[1], "pvalue" = pval)
}

# Helper function: Paired Multivariate Hotelling's T-Squared Test

.Hotelling_mv_T2 <- function(input, Group1, Group2, save_table_loc){
  # Rename groups
  input_data <- input %>% dplyr::select("pairing",
                                        "Taxon" = "taxon",
                                        "Group1" = tidyr::starts_with(Group1),
                                        "Group2" = tidyr::starts_with(Group2))
  # Check that there is only one observation per group.
  nonuniq_obs <- input_data %>%
    dplyr::group_by(.data$pairing, .data$Taxon) %>%
    dplyr::summarize("count" = dplyr::n(), .groups = "drop") %>%
    dplyr::filter(.data$count > 1) %>%
    nrow()
  if(nonuniq_obs > 0) message("More than one observation per unit/group detected")
  # Define n
  all_pairs <- unique(input_data$pairing)
  n <- length(all_pairs)
  p <- length(unique(input_data$Taxon))
  # Check that it won't be singular
  # n - p < 1
  if (n - p < 1) stop("num_taxa must be no larger than ", n - 1)
  # Sample mean vector
  Y_i <- input_data %>%
    dplyr::group_by(.data$pairing, .data$Taxon) %>%
    dplyr::summarise(Yi = .data$Group1 - .data$Group2,
                     .groups = "drop")
  Ybar <- Y_i %>%
    dplyr::group_by(.data$Taxon) %>%
    dplyr::summarise(Ybar = mean(.data$Yi),
                     .groups = "drop")
  # Y_i - Ybar
  diff <- Y_i %>%
    dplyr::left_join(Ybar, by = "Taxon") %>%
    dplyr::group_by(.data$pairing, .data$Taxon) %>%
    dplyr::summarise("diff" = .data$Yi - .data$Ybar, .groups = "drop")
  # (y_i-Ybar)%*%(y_i-Ybar)'
  mult_func <- function(x) {
    vec <- t(t(diff$diff[diff$pairing == x]))
    vec %*% t(vec)
  }
  # Calculate S_Y
  # Sample Var-cov matrix of vecs Y_i
  S_Y <- 1/(n - 1) * base::Reduce("+", lapply(all_pairs, mult_func))
  # Calculate T^2
  # T^2 = n*Ybar'*inv(S_Y)*Ybar
  Ybar_v <- t(t(Ybar$Ybar))
  T_2 <- n * t(Ybar_v) %*% solve(S_Y) %*% Ybar_v
  #F statistic
  # Dist according to F_p,n-p
  F_stat <- (n - p) / (p * (n - 1)) * T_2
  # Reject H0 at alpha if F-val exceeds
  df1 <- p
  df2 <- n - p
  crit_F <- stats::qf(0.95, df1, df2)
  pval <- 1 - stats::pf(c(F_stat), df1, df2)
  
  # Conduct a paired t-test
  # Following # 1 in R&C pg. 140
  if(pval < 0.05) {
    ttest_paired <- function(tax) {
      for_testing <- input_data %>% dplyr::filter(.data$Taxon == tax)
      out_test <- stats::t.test(x = for_testing$Group1,
                                y = for_testing$Group2,
                                alternative = "two.sided",
                                paired = TRUE, var.equal = TRUE)
      output <- list("t" = as.numeric(out_test$statistic),
                     "df" = as.numeric(out_test$parameter),
                     "diff_means" = as.numeric(out_test$estimate),
                     "CI_2.5" = as.numeric(out_test$conf.int[1]),
                     "CI_97.5" = as.numeric(out_test$conf.int[2]),
                     "p-value" = as.numeric(out_test$p.value))
      return(lapply(output, base::round, digits = 4))
    }
    results <- plyr::aaply(unique(input_data$Taxon), 1, ttest_paired)
    results_2 <- cbind(results, "adj p-value" = stats::p.adjust(results[, "p-value"],
                                                                method = "bonferroni"))
    # Write results
    filename_out <- paste0("ttest_results", Group1, Group2, ".csv")
    utils::write.csv(results_2, file.path(save_table_loc, filename_out))
    message("Results from t-tests written to ", filename_out)
  }
  
  return(list("df1" = df1, "df2" = df2, "crit_F" = crit_F,
              "F_stat" = F_stat[1], "pvalue" = pval))
}

#' Conduct a multivariate Hotelling's T-squared test
#'
#' This function takes an animalcules-formatted \code{MultiAssayExperiment}
#' object and runs a multivariate Hotelling's T-squared test. The test expects
#' a comparison of two distinct groups, and compares the abundances of the top microbes at a
#' given taxon level between the groups. This function allows both paired and unpaired
#' tests. Both test the null hypothesis that the population
#' mean vectors are equal, with the alternative being that they are unequal.
#' 
#' The Hotelling's t-squared statistic (t2) is a generalization of
#' Student's t-statistic that is used in multivariate hypothesis testing
#' to test the means of different populations.
#' 
#' Note that any entries or pairs with missing values are excluded.
#' 
#' Referenced articles in the implementation of tests:
#'
#' https://online.stat.psu.edu/stat505/lesson/7/7.1/7.1.14
#' 
#' https://online.stat.psu.edu/stat505/lesson/7/7.1/7.1.15
#' 
#' https://online.stat.psu.edu/stat505/lesson/7/7.1/7.1.4
#' 
#' https://online.stat.psu.edu/stat505/lesson/7/7.1/7.1.9
#'
#' @param dat A MultiAssayExperiment object specially formatted as an animalcules output.
#' @param test_index Any argument used for subsetting the input \code{dat},
#' can be a character, logical, integer, list or List vector. Default is \code{NULL}.
#' @param taxon_level Character string, default is \code{"genus"}.
#' @param num_taxa The number of most abundant taxa to test. If unpaired, this should
#' be no larger than the total number of subjects in both groups - 2, or (n1 + n2 -2).
#' If paired, this should be no larger than the total number of pairs - 1, or n - 1.
#' Required.
#' @param grouping_var Character string, the name of a DICHOTOMOUS grouping variable in the
#' metadata of \code{dat}.
#' @param paired Logical indicating whether a paired test should be conducted.
#' Default is \code{FALSE} for an unpaired test.
#' @param pairing_var Character string giving the variable containing pairing information.
#' The variable should be in integer form. Must be supplied if \code{paired = TRUE},
#' otherwise the default is NULL.
#' @param unit_var Character string giving the variable containing the identifiers
#' for the unit on which multiple measurements were conducted, e.g. subjects. Default is
#' \code{NULL}; must be supplied if \code{paired = FALSE}.
#' @param save_table_loc A character string giving the folder path to save t.test results.
#' Note that these are only conducted if the Hotelling's T-test value is <0.05. 
#' Defaults to the current working directory.
#' 
#' @return A list of the elements "df1", "df2", "crit_F", "F_stat" and "pvalue" giving the
#' results of the test.
#'
#' @export
#' @importFrom rlang .data
#'
#' @examples
#' dat <- system.file("extdata", "MAE.RDS", package = "LegATo") |>
#' readRDS()
#' dat_0.05 <- filter_MAE(dat, 0.001, 10, "species")
#' out1 <- test_hotelling_t2(dat = dat_0.05,
#'                   test_index = which(dat_0.05$MothChild == "Infant" &
#'                                        dat_0.05$timepoint == 0),
#'                   taxon_level = "genus",
#'                   # Total number of pairs - 1
#'                   num_taxa = 9,
#'                   paired = TRUE,
#'                   grouping_var = "HIVStatus",
#'                   pairing_var = "pairing")
#' out1                  
#' 
#' out <- test_hotelling_t2(dat = dat_0.05,
#'                   test_index = which(dat_0.05$MothChild == "Mother" &
#'                                        dat_0.05$timepoint == 6),
#'                   taxon_level = "genus",
#'                   # Max is Total number of subjects - 2
#'                   # Here we use a much smaller number
#'                   num_taxa = 6,
#'                   grouping_var = "HIVStatus",
#'                   unit_var = "Subject",
#'                   paired = FALSE)
#' out                  
#'

test_hotelling_t2 <- function(dat,
                              test_index = NULL,
                              taxon_level = "genus",
                              num_taxa, grouping_var,
                              paired = FALSE,
                              pairing_var = NULL,
                              unit_var = NULL,
                              save_table_loc = ".") {
  MAE <- dat
  if (!is.null(test_index)) MAE <- MultiAssayExperiment::subsetByColData(dat, test_index)
  best_taxa <- get_top_taxa(MAE, taxon_level) %>%
    dplyr::pull(.data$taxon)
  input_data <- get_long_data(MAE, taxon_level, log = TRUE,
                              counts_to_CPM = TRUE) %>%
    dplyr::filter(.data$taxon %in% best_taxa[seq_len(num_taxa)]) 
  
  if (paired) {
    if (is.null(pairing_var)) message("Please supply pairing_var if paired = TRUE")
    output_data <- input_data %>%
      dplyr::select(dplyr::all_of(c(grouping_var, pairing_var)), "taxon",
                    "Abundance") %>%
      tidyr::pivot_wider(id_cols = dplyr::all_of(c("taxon", pairing_var)),
                         values_from = "Abundance",
                         names_from = dplyr::all_of(grouping_var)) %>%
      dplyr::arrange(.data$pairing) %>%
      dplyr::filter(!dplyr::if_any(tidyselect::everything(), is.na))
    # Ensure dichotomous
    all_vars <- unique(input_data[, grouping_var])
    if(length(all_vars) != 2) {
      stop("grouping_var must be dichotomous")
    } else results <- .Hotelling_mv_T2(output_data, all_vars[1],
                                       all_vars[2], save_table_loc)
  } else {
    if (is.null(unit_var)) message("Please supply unit_var if paired = FALSE")
    output_data <- input_data %>%
      dplyr::select("taxon", dplyr::all_of(c(unit_var, grouping_var)), "Abundance") %>%
      dplyr::arrange(.data[[unit_var]]) %>%
      dplyr::filter(!dplyr::if_any(tidyselect::everything(), is.na))
    results <- .Hotelling_mv_T2_un(output_data, grouping_var, unit_var, "taxon",
                                   save_table_loc, num_taxa)
  }
  return(results)
}

utils::globalVariables(".")

#' Create a long data.frame with grouped abundances from a MultiAssayExperiment counts object
#' 
#' This function takes a \code{MultiAssayExperiment} object and a specified
#' taxon level of interest and creates a long \code{data.frame} that can be used
#' more easily for plotting counts data in a stacked bar plot or a stacked area
#' chart. The function groups taxa and computes relative abundance within taxa strata.
#' 
#' @inheritParams plot_spaghetti
#' 
#' @return A \code{data.frame} consisting of the counts data, taxa, and metadata.
#'
#' @export
#' @importFrom rlang .data
#' 
#' @examples
#' in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
#' get_stacked_data(in_dat, "genus", covariate_1 = "Sex", covariate_time = "Month")
#'

get_stacked_data <- function(dat, taxon_level = "genus",
                             covariate_1,
                             covariate_time) {
  microbe <- parse_MAE_SE(dat)
  
  if (is.null(covariate_1)) {
    relabu_table <- microbe$counts %>%
      animalcules::upsample_counts(., microbe$tax, taxon_level) %>%
      animalcules::counts_to_relabu() %>% t() %>% as.data.frame() %>%
      # Add grouping vars
      dplyr::mutate("covariate_t" = microbe$sam[, covariate_time]) %>%
      tidyr::pivot_longer(!"covariate_t", names_to = "taxon") %>%
      S4Vectors::aggregate(. ~ taxon + `covariate_t`, ., mean)
  } else {
    relabu_table <- microbe$counts %>%
      animalcules::upsample_counts(., microbe$tax, taxon_level) %>%
      animalcules::counts_to_relabu() %>% t() %>% as.data.frame() %>%
      # Add grouping vars
      dplyr::mutate("covariate_1" = microbe$sam[, covariate_1],
                    "covariate_t" = microbe$sam[, covariate_time]) %>%
      tidyr::pivot_longer(!c("covariate_1", "covariate_t"), names_to = "taxon") %>%
      S4Vectors::aggregate(. ~ taxon + covariate_1 + covariate_t, ., mean)
  }
  # formula for covariates
  return(relabu_table)
}

#' Filter a MultiAssayExperiment object to keep a top percentage of taxa
#' 
#' This function takes an animalcules-formatted \code{MultiAssayExperiment} (MAE)
#' object and identifies all taxa at the OTU level of choice that exhibit a
#' relative abundance greater than or equal to a relative abundance percent
#' threshold, \code{relabu_threshold}, in at least \code{occur_pct_cutoff}\% of
#' the total samples. After filtration, taxa across the specified OTU level and
#' all downstream levels are then consolidated into the category "Other".
#' @inheritParams plot_stacked_bar
#' @param relabu_threshold A double(percentage) between 0 and 100, representing
#' the relative abundance criterion that all OTUs should meet to be retained.
#' The smaller the threshold, the fewer the OTUs will be retained. Default is
#' 3\%.
#' @param occur_pct_cutoff A double (percentage) between 0 and 100
#' representing the percent cutoff for how many OTUs must meet the
#' \code{relabu_threshold} across the samples to be retained. It is wise to
#' keep the number of samples in mind when setting this parameter. Default is 5\%.
#' @returns An animalcules-formatted \code{MultiAssayExperiment} object
#' with major OTUs retained.
#' @export
#' @importFrom rlang .data
#' @examples
#'   in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |>
#'     readRDS()
#'   filter_MAE(in_dat, relabu_threshold = 3, occur_pct_cutoff = 5,
#'              taxon_level = "genus")
#'

filter_MAE <- function(dat, relabu_threshold = 3, occur_pct_cutoff = 5,
                       taxon_level = "genus") {
  if(relabu_threshold < 0 | relabu_threshold > 100) {
    stop("relabu_threshold must be between 0 and 100.")
  } else if(occur_pct_cutoff < 0 | occur_pct_cutoff > 100) {
    stop("occur_pct_cutoff must be between 0 and 100.")
  }
  
  # Extract metadata, taxonomic info, and counts
  parsed <- parse_MAE_SE(dat, type = "MAE")
  tax_table <- parsed$tax
  sam_table <- parsed$sam
  counts_table <- parsed$counts
  # upsample if needed
  up_counts <- animalcules::upsample_counts(counts_table, tax_table,
                                            taxon_level)
  
  samp_range <- range(colSums(counts_table))
  message("The overall range of relative abundance ",
          "counts between samples is (", samp_range[1], ", ",
          samp_range[2], ") \n")
  
  otu.pct <- up_counts %>%
    as.matrix() %>%
    # Get rel abu within samples
    prop.table(margin = 2) 
  
  # prune the OTUs
  # quantile(round(rowMeans(otu.pct), 2))
  otu.select <- apply(otu.pct, 1,
                      # Proportion of samples that the OTU relabu proportion
                      # is greater than relative abundance threshold
                      function(x) sum(x >= relabu_threshold/100) / length(x)) %>%
    # Taking that proportion and checking if that
    # occurrence rate is greater than or equal to the cutoff
    magrittr::is_weakly_greater_than(occur_pct_cutoff / 100)
  # Replace any NAs that were already in table for specified tax level
  tax_table[, taxon_level] <- replace(tax_table[, taxon_level],
                                      is.na(tax_table[, taxon_level]),
                                      "Unknown")
  # Everything to the right of taxon_level should change to "other"
  tax_in_table <- colnames(tax_table)
  tax_ind <- which(tax_in_table == taxon_level)
  tax_to_change <- unique(tax_in_table[tax_ind:length(tax_in_table)])
  tax_table_other <- tax_table |>
    dplyr::mutate(dplyr::across(dplyr::all_of(tax_to_change),
                                function(x) replace(x, !otu.select, 
                                                    "Other")))
  
  # Resum the counts table at lowest level
  low_tax <- tax_in_table[length(tax_in_table)]
  counts_other <- counts_table %>%
    dplyr::bind_cols("OTU" = tax_table_other[, low_tax]) %>%
    dplyr::relocate("OTU") %>%
    dplyr::group_by(.data$OTU) %>%
    dplyr::summarise(dplyr::across(.cols = dplyr::all_of(colnames(counts_table)),
                                   .fns = sum)) %>%
    tibble::column_to_rownames("OTU")
  
  # Adjust tax table accordingly
  tax_table_other2 <- tax_table_other %>%
    dplyr::distinct(.data[[low_tax]], .keep_all = TRUE) %>%
    dplyr::arrange(.data[[low_tax]])
  
  rownames(tax_table_other2) <- tax_table_other2[, low_tax]
  message("Number of OTUs that exhibit a relative abundance >",
          relabu_threshold, "% in at least ",
          occur_pct_cutoff, "% of the total samples: ",
          nrow(tax_table_other2), "/", nrow(tax_table), "\n")
  ## Create SE object
  MAE_out <- create_formatted_MAE(counts_other, tax_table_other2, sam_table)
  return(MAE_out)
}

## ----MAE_SE_install, eval = FALSE---------------------------------------------
# if (!requireNamespace("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# 
# BiocManager::install("MultiAssayExperiment")
# BiocManager::install("SummarizedExperiment")

## ----load_LegATo, eval = FALSE------------------------------------------------
# BiocManager::install("wejlab/LegATo")

## -----------------------------------------------------------------------------
library(LegATo)

## -----------------------------------------------------------------------------
library(ggeffects)
library(emmeans)

## -----------------------------------------------------------------------------
counts <- system.file("extdata", "counts.csv", package = "LegATo") |>
  read.csv(row.names = 1) |>
  dplyr::rename_with(function(x) stringr::str_replace(x, "\\.", "-"))
tax <- system.file("extdata", "tax.csv", package = "LegATo") |> read.csv(row.names = 1)
sample <- system.file("extdata", "sample.csv", package = "LegATo") |> read.csv(row.names = 1)

## -----------------------------------------------------------------------------
ndim <- 5
counts[seq_len(ndim), seq_len(ndim)] |>
  knitr::kable(caption = "Counts Table Preview",
               label = NA)

tax[seq_len(ndim), ] |>
  knitr::kable(caption = "Taxonomy Table Preview",
               label = NA)

sample[seq_len(ndim), ] |>
  knitr::kable(caption = "Sample Table Preview",
               label = NA)

## -----------------------------------------------------------------------------
output <- create_formatted_MAE(counts_dat = counts,
                               tax_dat = tax,
                               metadata_dat = sample)

class(output)
MultiAssayExperiment::assays(output)
SummarizedExperiment::assays(output[["MicrobeGenetics"]])

## -----------------------------------------------------------------------------
dat <- system.file("extdata", "MAE.RDS", package = "LegATo") |>
  readRDS()

dat_subsetted <- MultiAssayExperiment::subsetByColData(dat,
                                                       dat$MothChild == "Infant")

## -----------------------------------------------------------------------------
dat_cleaned <- clean_MAE(dat_subsetted)

## -----------------------------------------------------------------------------
dat_filt_1 <- filter_MAE(dat_cleaned, relabu_threshold = 0.05, occur_pct_cutoff = 10)

## -----------------------------------------------------------------------------
dat_filt <- filter_animalcules_MAE(dat_cleaned, 0.05)

## -----------------------------------------------------------------------------
parsed <- parse_MAE_SE(dat_filt, type = "MAE")

parsed$counts[seq_len(5), seq_len(5)] |> 
  knitr::kable(caption = "Counts Table")

parsed$sam[seq_len(5), ]  |>
  knitr::kable(caption = "Sample Metadata")

parsed$tax[seq_len(5), ] |> 
  knitr::kable(caption = "Taxonomy Table")


## -----------------------------------------------------------------------------
group_vars <- c("HIVStatus", "MothChild")
get_summary_table(dat_filt, group_vars) |>
  knitr::kable(caption = "Summary Table", label = NA)

## -----------------------------------------------------------------------------
best_genus <- get_top_taxa(dat_filt, "genus")
best_genus |> knitr::kable(caption = "Table of genera, ranked by abundance")

## -----------------------------------------------------------------------------
longdat <- get_long_data(dat_filt, "genus", log = TRUE, counts_to_CPM = TRUE)

stackeddat <- get_stacked_data(dat_filt, "genus", covariate_1 = "HIVStatus",
                               covariate_time = "timepoint")

## -----------------------------------------------------------------------------
this_palette <- c("#709AE1", "#8A9197", "#D2AF81", "#FD7446", "#D5E4A2", "#197EC0", "#F05C3B", "#46732E",
                  "#71D0F5", "#370335", "#075149", "#C80813", "#91331F", "#1A9993", "#FD8CC1") |>
  magrittr::extract(seq_len(nrow(best_genus)))

## -----------------------------------------------------------------------------
plot_alluvial(dat = dat_filt, 
              taxon_level = "genus", 
              covariate_1 = "HIVStatus",
              covariate_time = "timepoint",
              palette_input = this_palette,
              subtitle = "Alluvial plot")

## ----results = "asis", message = FALSE----------------------------------------
  plot_spaghetti(dat = dat_filt,
               covariate_time = "timepoint",
               covariate_1 = "HIVStatus",
               unit_var = "Subject",
               taxon_level = "genus",
               which_taxon = "Staphylococcus",
               palette_input = this_palette,
               title = "Spaghetti Plot",
               subtitle = NULL) +
  ggplot2::xlab("Infant Age (timepoint)") +
  ggplot2::ylab("Relative Abundance (log CPM)")

## -----------------------------------------------------------------------------
plot_stacked_bar(dat_filt, "genus", 
             "HIVStatus",
             "timepoint",
             palette_input = this_palette)

## -----------------------------------------------------------------------------
plot_stacked_area(dat_filt, "genus", 
                  "HIVStatus",
                  "timepoint",
                  palette_input = this_palette)

## -----------------------------------------------------------------------------
this_taxon <- parsed$counts |>
  animalcules::upsample_counts(parsed$tax, "genus") |>
  animalcules::counts_to_logcpm()
p <- plot_heatmap(inputData = this_taxon,
                  annotationData = dplyr::select(parsed$sam, "timepoint", "HIVStatus", "pairing"),
                  name = "Data",
                  plot_title = "Example",
                  plottingColNames = NULL,
                  annotationColNames = NULL,
                  colList = list(),
                  scale = FALSE,
                  showColumnNames = FALSE,
                  showRowNames = FALSE,
                  colorSets = c("Set1", "Set2", "Set3", "Pastel1", "Pastel2", "Accent", "Dark2",
                                "Paired"),
                  choose_color = c("blue", "gray95", "red"),
                  split_heatmap = "none",
                  column_order = NULL
)

## -----------------------------------------------------------------------------
dat_1 <- filter_MAE(dat_cleaned, 0.05, 10, "species")

NMIT(dat_1, unit_var = "Subject", fixed_cov = "HIVStatus",
     covariate_time = "timepoint",
     method = "kendall", dist_type = "F",
     heatmap = TRUE, classify = FALSE, fill_na = 0)

## -----------------------------------------------------------------------------
test_hotelling_t2(dat = dat_1,
                  test_index = which(dat_filt$MothChild == "Infant" &
                                       dat_filt$timepoint == 6),
                  taxon_level = "genus",
                  num_taxa = 6,
                  paired = TRUE,
                  grouping_var = "HIVStatus",
                  pairing_var = "pairing")

## -----------------------------------------------------------------------------
test_hotelling_t2(dat = dat_1,
                  test_index = which(dat_filt$timepoint == 0),
                  taxon_level = "genus",
                  num_taxa = 6,
                  grouping_var = "HIVStatus",
                  unit_var = "Subject",
                  paired = FALSE)


## -----------------------------------------------------------------------------
output <- run_gee_model(dat_1, unit_var = "Subject",
                        fixed_cov = c("HIVStatus", "timepoint"),
                        corstr = "ar1",
                        plot_out = FALSE,
                        plotsave_loc = ".",
                        plot_terms = NULL)

head(output) |> knitr::kable(caption = "GEE Outputs")

## ----out.width = "50%", fig.align = "center", echo = FALSE--------------------
tempfolder <- tempdir()

# Trying out plotting
output <- run_gee_model(dat_1, unit_var = "Subject",
              taxon_level = "genus",
              fixed_cov = c("HIVStatus", "timepoint"),
              corstr = "ar1",
              plot_out = TRUE,
              plotsave_loc = tempfolder,
              plot_terms = "timepoint",
              width = 6, height = 4, units = "in", scale = 0.7)

list.files(tempfolder) |> head()

## -----------------------------------------------------------------------------
# If there are issues with matrix being positive definite
# Revisit filtering parameters in filter_MAE
output <- run_lmm_model(dat_1, unit_var = "Subject",
                        taxon_level = "genus",
                        fixed_cov = c("timepoint", "HIVStatus"),
                        plot_out = FALSE,
                        plotsave_loc = ".",
                        plot_terms = NULL)

head(output) |> knitr::kable(caption = "LMM Outputs")

## -----------------------------------------------------------------------------
sessionInfo()

#' Create a table summarizing reads aggregated by grouping variables on a unit
#' 
#' This function takes a \code{MultiAssayExperiment} of microbial read counts
#' and aggregates them by one or more grouping vars within a unit.
#' 
#' @inheritParams plot_stacked_bar
#' @param group_vars A character string or character vector of covariates
#' found in \code{colData(dat)} to use in grouping counts. The variables
#' should be listed in order of desired grouping. Default is \code{NULL},
#' which does not rely on a grouping variable and instead produces statistics
#' for the entirety of the data.
#' 
#' @return A \code{data.frame} of the grouping columns, mean_reads, sd_reads,
#' min_reads, max_reads and num_total.
#'
#' @export
#' @importFrom rlang .data
#'
#' @examples
#' in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
#' out <- get_summary_table(in_dat, c("Group", "Subject"))
#' head(out)
#'

get_summary_table <- function(dat, group_vars = NULL) {
  microbe <- parse_MAE_SE(dat)
  counts_table <- microbe$counts
  tax_table <- microbe$tax
  sam_table <- microbe$sam
  
  reads_tbl <- counts_table %>%
    tidyr::as_tibble() %>%
    dplyr::mutate(species = tax_table$species) %>%
    dplyr::relocate(.data$`species`) %>%
    tidyr::pivot_longer(cols = tidyr::all_of(colnames(counts_table)),
                        names_to = "Sample_id",
                        values_to = "Abundance") %>%
    dplyr::group_by(.data$Sample_id) %>%
    dplyr::summarise(TotalAbundance = sum(.data$Abundance)) %>%
    dplyr::left_join(tibble::rownames_to_column(sam_table, "Sample_id"),
                     by = "Sample_id")
  
  if (!is.null(group_vars)) {
    reads_tbl <- reads_tbl %>%
      dplyr::group_by(dplyr::across(dplyr::all_of(c(group_vars))))
  }
  summary_tab <- reads_tbl %>%
    dplyr::summarise(mean_reads = base::mean(.data$TotalAbundance),
                     sd_reads = stats::sd(.data$TotalAbundance),
                     min_reads = base::min(.data$TotalAbundance),
                     max_reads = base::max(.data$TotalAbundance),
                     num_total = dplyr::n()) %>%
    as.data.frame()
  
  return(summary_tab)
}

#' Plot an alluvial diagram of microbial relative abundance
#'
#' This function takes a \code{MultiAssayExperiment} object and returns a
#' alluvial diagram of microbe relative abundances. The function takes a single
#' covariate as an optional variable by which to create a grid of multiple
#' plots. Note, the ggalluvial package is required to use this function.
#'
#' If further manipulation of specific parameters is desired, users can add
#' \code{ggplot2} function calls to the output of the function.
#'
#' @inheritParams plot_stacked_bar
#'
#' @return A \code{ggplot2} plot.
#'
#' @export
#' @importFrom rlang .data
#'
#' @examples
#' in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
#' plot_alluvial(in_dat, taxon_level = "family", covariate_1 = "Group", covariate_time = "Month",
#'               palette_input = rainbow(25))
#'

plot_alluvial <- function(dat,
                          taxon_level,
                          covariate_1 = NULL,
                          covariate_time,
                          palette_input = NULL,
                          title = paste("Relative abundance at", taxon_level, "level"),
                          subtitle = NULL) {
  if (!requireNamespace("ggalluvial", quietly = TRUE)) {
    message("The 'ggalluvial' package is not installed",
            "Please install it from CRAN to use this function.")
  }
  
  relabu_table <- get_stacked_data(dat, taxon_level, covariate_1, covariate_time)
  
  taxa_ordered <- get_top_taxa(dat, taxon_level) %>%
    dplyr::pull(.data$taxon)
  
  myplot <- relabu_table %>%
    dplyr::mutate("Taxon" = factor(.data$taxon, levels = taxa_ordered),
                  "Timepoint" = as.factor(.data$covariate_t),
                  "covariate_1" = factor(.data$covariate_1)) %>%
    dplyr::rename("Relative abundance" = .data$value) %>%
    dplyr::select("covariate_1", "Timepoint", "Taxon", "Relative abundance") %>%
    ggplot2::ggplot(ggplot2::aes(y = .data$`Relative abundance`,
                                 x = .data$Timepoint, alluvium = .data$Taxon)) +
    ggalluvial::geom_alluvium(ggplot2::aes(fill = .data$Taxon,
                                           color = .data$Taxon),
                              width = 1/4, alpha = 0.7, decreasing = FALSE) +
    ggplot2::theme_classic() +
    ggplot2::labs(x = "Timepoint", y = "Relative abundance",
                  title = title, subtitle = subtitle) +
    ggplot2::theme(legend.position = "bottom",
                   legend.title = ggplot2::element_blank())
  if (!is.null(palette_input)) {
    myplot <- myplot +
      ggplot2::scale_fill_manual(values = palette_input) +
      ggplot2::scale_color_manual(values = palette_input)
  }
  if (!is.null(covariate_1)) {
    myplot <- myplot +
      ggplot2::facet_grid(~.data$covariate_1)
  }
  
  return(myplot)
}

#' Parse a MultiExperimentAssay object and extract the elements as data.frames
#'
#' This function takes an animalcules-formatted \code{MultiAssayExperiment}
#' object and parses it to extract a named assay alongside the taxonomy and
#' metadata.
#'
#' @param dat Either a \code{MultiAssayExperiment} or a
#'   \code{SummarizedExperiment} object.
#' @param which_experiment Character string. If \code{type = "MAE"}, then
#' this is the name of the experiment to be accessed. If \code{NULL},
#' will default to the first available experiment.
#' @param which_assay Character string. Regardless of whether 
#' \code{type = "MAE"} or \code{"SE"}, this is the name of the selected
#' \code{SummarizedExperiment} object. If \code{NULL}, defaults to first listed.
#' @param type One of "MAE" denoting a \code{MultiAssayExperiment} or "SE"
#'   denoting a \code{SummarizedExperiment}.
#'
#' @returns Returns a list of 3 named data.frame elements, `counts`, `sam`, and
#'   `tax` denoting the counts data, sample metadata table, and taxonomy table,
#'   respectively.
#'
#' @export
#' @importFrom rlang .data
#' @import MultiAssayExperiment
#'
#' @examples
#' in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
#' out <- parse_MAE_SE(in_dat)
#' head(out$tax)
#' head(out$sam)
#' head(out$counts)
#' 
#' out2 <- parse_MAE_SE(in_dat[["MicrobeGenetics"]],
#'                      which_assay = "MGX", type = "SE")
#' 

parse_MAE_SE <- function(dat, which_experiment = NULL,
                         which_assay = NULL, type = "MAE") {
    if (type == "MAE") {
        if (is.null(which_experiment)) {
            which_experiment <- names(MultiAssayExperiment::assays(dat))[1]
        } 
        if (!methods::is(dat, "MultiAssayExperiment")) {
            stop("Input must be a MultiAssayExperiment")
        }
        microbe <- dat[[which_experiment]]
    } else if (type == "SE") {
        microbe <- dat
    } else stop("type must be one of 'SE' or 'MAE'")
    
    if (is.null(which_assay)) {
        which_assay <- names(SummarizedExperiment::assays(microbe))[1]
    }
    
    # Extract metadata, taxonomic info, and counts
    tax_table <- as.data.frame(SummarizedExperiment::rowData(microbe))
    sam_table <- as.data.frame(SummarizedExperiment::colData(microbe))
    
    SE_assay <- SummarizedExperiment::assay(microbe, which_assay)
    counts_table <- as.data.frame(SE_assay)[, rownames(sam_table)]
    
    list(counts = counts_table,
         sam = sam_table,
         tax = tax_table) %>%
        return()
}

#' Plot a spaghetti volatility plot of microbial abundance for a given taxon
#'
#' This function takes a \code{MultiAssayExperiment} object and returns a
#' spaghetti plot of microbial abundance delineated by a unit, such as
#' a subject.
#'
#' If further manipulation of specific parameters is desired, users can add
#' \code{ggplot2} function calls to the output of the function.
#'
#' @inheritParams plot_stacked_bar
#' @param covariate_1 Character string, the name of the covariate in `dat`
#' by which to color and group samples. Default is \code{NULL}.
#' @param unit_var Character string, the name of the column delineating the
#' unit on which the microbial abundances are changing over time. This is
#' likely something akin to a subject that repeated measurements are made on.
#' @param which_taxon Character string, the name of the taxon to plot at the
#' specified taxon level.
#'
#' @return A \code{ggplot2} plot.
#'
#' @export
#' @importFrom rlang .data
#'
#' @examples
#' in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
#' all_taxa <- get_top_taxa(in_dat, "phylum")
#' plot_spaghetti(in_dat, taxon_level = "phylum", covariate_1 = "Group", covariate_time = "Month",
#'               unit_var = "Subject", which_taxon = all_taxa$taxon[1],
#'               palette_input = rainbow(25))
#'

plot_spaghetti <- function(dat,
                           covariate_time,
                           covariate_1 = NULL,
                           unit_var,
                           taxon_level,
                           which_taxon,
                           palette_input= NULL,
                           title = "Spaghetti Plot",
                           subtitle = NULL) {
  input_data <- get_long_data(dat, taxon_level, log = TRUE,
                              counts_to_CPM = TRUE) %>%
    dplyr::filter(.data$taxon == which_taxon)
  p <- input_data %>%
    ggplot2::ggplot(ggplot2::aes(x = !!rlang::sym(covariate_time),
                                 y = .data$Abundance,
                                 group = !!rlang::sym(unit_var),
                                 color = !!rlang::sym(covariate_1))) +
    ggplot2::geom_line(alpha = 0.7) +
    ggplot2::geom_point(alpha = 0.7, size = 0.5) +
    ggplot2::labs(title = "Spaghetti plot of microbe abundance",
                  subtitle = which_taxon) +
    ggplot2::theme_bw()
  
  if (!is.null(palette_input)) {
    p <- p + ggplot2::scale_color_manual(values = palette_input)
  }
  if(!is.null(covariate_1)) {
    p <- p + ggplot2::facet_wrap(rlang::sym(covariate_1))
  }
  return(p)
}

#' Plot a stacked bar chart of microbial relative abundance
#'
#' This function takes a \code{MultiAssayExperiment} object and returns a
#' stacked bar plot of microbe relative abundances. The function takes a single
#' covariate as an optional variable by which to create multiple gridded plots.
#'
#' If further manipulation of specific parameters is desired, users can add
#' \code{ggplot2} function calls to the output of the function.
#'
#' @param dat A \code{MultiAssayExperiment} object specially formatted as an
#'   animalcules output.
#' @param taxon_level Character string indicating the level of taxonomy to
#'   aggregate the counts data. Must be the name of a column in
#'   \code{MultiAssayExperiment::rowData(dat)}.
#' @param covariate_1 Character string giving the name of a column in
#'   \code{MultiAssayExperiment::colData(dat)} on which to create multiple
#'   plots. The default is \code{NULL}.
#' @param covariate_time Character string giving the name of the discrete
#'   time-based covariate in the metadata to group abundances by.
#' @param palette_input A character vector of colors that is at minimum the same
#'   length of the number of taxa (specified with \code{taxon_level}).
#'   The default is \code{NULL} and relies on \code{ggplot2}'s default scheme.
#' @param title A character string providing the plot title.
#' @param subtitle A character string providing the plot subtitle. The default
#'   is \code{NULL}.
#'
#' @return A \code{ggplot2} plot.
#'
#' @export
#' @importFrom rlang .data
#'
#' @examples
#' in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
#' plot_stacked_bar(in_dat, taxon_level = "family", covariate_1 = "Group",
#'                   covariate_time = "Month",
#'                   palette_input = rainbow(25))
#'

plot_stacked_bar <- function(dat,
                             taxon_level,
                             covariate_1 = NULL,
                             covariate_time,
                             palette_input= NULL,
                             title = paste("Relative abundance at", taxon_level, "level"),
                             subtitle = NULL) {
  relabu_table <- get_stacked_data(dat, taxon_level, covariate_1, covariate_time)
  
  taxa_ordered <- get_top_taxa(dat, taxon_level) %>%
    dplyr::pull(.data$taxon)
  
  myplot <- relabu_table %>%
    dplyr::mutate("Taxon" = factor(.data$taxon, levels = taxa_ordered),
                  "Timepoint" = factor(.data$covariate_t)) %>%
    dplyr::rename("Relative abundance" = .data$value) %>%
    ggplot2::ggplot(ggplot2::aes(fill = .data$Taxon, x = .data$Timepoint, y = .data$`Relative abundance`)) + 
    ggplot2::geom_bar(position = "stack", stat = "identity") +
    ggplot2::theme_classic() +
    ggplot2::labs(title = title,
                  subtitle = subtitle) +
    ggplot2::theme(legend.position = "bottom",
                   #axis.title.x = element_blank(), axis.text.x = element_blank(),
                   axis.ticks.x = ggplot2::element_blank(),
                   legend.title = ggplot2::element_blank()) +
    ggplot2::coord_flip()
  
  if (!is.null(palette_input)) {
    myplot <- myplot +
      ggplot2::scale_fill_manual(values = palette_input)
  }
  if (!is.null(covariate_1)) {
    myplot <- myplot +
    ggplot2::facet_grid(~.data$covariate_1)
  }
  
  return(myplot)
}

#' Generate a distinct palette for coloring different clusters.
#'
#' Create a distinct palette for coloring different heatmap clusters. The
#' function returns colors for input into \code{ComplexHeatmap:Heatmap()}.
#' The "grDevices" package is required to use this function.
#'
#' @param n an integer describing the number of colors to generate. Required.
#' @param hues a vector of character strings indicating the R colors available
#' from the \code{colors()} function. These will be used as the base colors for
#' the clustering scheme. Different saturations and values (i.e. darkness)
#' will be generated for each hue. Default is \code{c("red", "cyan", "orange",
#' "blue", "yellow", "purple", "green", "magenta")}
#' @param saturation.range a numeric vector of length 2 with values between 0
#' and 1 giving the range of saturation. The default is \code{c(0.25, 1)}.
#' @param value.range a numeric vector of length 2 with values between 0 and 1
#' giving the range of values. The default is \code{c(0.5, 1)}.
#'
#' @return A vector of distinct colors that have been converted to HEX from
#' HSV.
#'
#' @export
#'
#' @examples
#'
#' distinctColors(10)
#'
distinctColors <- function(n, hues = c("red", "cyan", "orange", "blue",
                                       "yellow", "purple", "green", "magenta"),
                           saturation.range = c(0.7, 1),
                           value.range = c(0.7, 1)) {
  
  if (!requireNamespace("grDevices", quietly = TRUE)) {
    message("The 'grDevices' package is not installed",
            "Please install it from CRAN to use this function.")
  }
  
  if (!(all(hues %in% grDevices::colors()))) {
    stop("Only color names listed in the 'color'",
         " function can be used in 'hues'")
  }
  
  ## Convert R colors to RGB and then to HSV color format
  hues.hsv <- grDevices::rgb2hsv(grDevices::col2rgb(hues))
  
  ## Calculate all combination of saturation/value pairs.
  ## Note that low saturation with low value (i.e. high darkness) is too dark
  ## for all hues. Likewise, high saturation with high value (i.e. low darkness)
  ## is hard to distinguish. Therefore, saturation and value are set to be
  ## anticorrelated.
  num.vs <- ceiling(n / length(hues))
  s <- seq(from = saturation.range[1], to = saturation.range[2],
           length = num.vs)
  v <- seq(from = value.range[2], to = value.range[1], length = num.vs)
  
  ## Create all combinations of hues with saturation/value pairs
  new.hsv <- dplyr::tibble(V1 = rep(hues.hsv[1, ], num.vs),
                           V2 = rep(s, each = length(hues)),
                           V3 = rep(v, each = length(hues))) |>
      t() |> as.matrix() |> magrittr::set_rownames(NULL)
  
  ## Convert to HEX
  col <- grDevices::hsv(new.hsv[1, ], new.hsv[2, ], new.hsv[3, ])
  
  return(col[seq_len(n)])
}

#' Plot a ComplexHeatmap.
#'
#' This function takes an arbitrary dataset as an input and returns a
#' \code{ComplexHeatmap} plot of samples based on similarity of microbial
#' abundances. The function takes arguments listed here as well
#' as any others to be passed on to \code{ComplexHeatmap::Heatmap()}. Note, the
#' "circlize" and "ComplexHeatmap" packages are required to use this function.
#'
#' If both \code{annotationData = NULL} and \code{annotationColNames = NULL},
#' no annotation bar will be drawn on the heatmap.
#' 
#' Code was adapted from the \code{TBSignatureprofiler} R package.
#'
#' @param inputData an input data object. It should either be of the class
#' \code{SummarizedExperiment} and contain the data and
#' annotation data as columns in the colData, or alternatively be of the classes
#' \code{data.frame} or \code{matrix} and contain only the plotting data.
#' Required.
#' @param annotationData a \code{data.frame} or \code{matrix} of annotation
#' data, with one column. Only required if \code{inputData} is a
#' \code{data.frame} or \code{matrix} of plotting data.
#' The row names must equal those of the \code{inputData} column names.
#' Default is \code{NULL}.
#' @param plot_title a character string with the plot title of the heatmap. The
#' default is \code{NULL}.
#' @param name a character string with the name of the data to be displayed.
#' Default is \code{"Input data"}.
#' @param plottingColNames a vector of the column names in \code{colData} that
#' contain the plotting data. Only required if \code{inputData} is a
#' SummarizedExperiment object.
#' @param annotationColNames a vector of the column names in \code{colData} that
#' contain the annotation data. Only required if \code{inputData} is a
#' \code{SummarizedExperiment}. Default is \code{NULL}.
#' @param colList a named \code{list} of named vectors specifying custom color
#' information to
#' pass to \code{ComplexHeatmap::Heatmap()}. The list should have as many
#' elements as there are annotation columns, and each element name should
#' correspond exactly with the name of each annotation column.
#' The colors in the vector elements should be named according to the
#' levels of the factor in that column's annotation data if the annotation
#' is discrete, or it should be produced with \code{circlize::colorRamp2}
#' if the annotation is continuous.
#' By default, \code{ColorBrewer} color sets will be used.
#' See the the parameter \code{colorSets} for additional details.
#' @param scale logical. Setting \code{scale = TRUE} scales the plotting data.
#' The default is \code{FALSE}.
#' @param showColumnNames logical. Setting \code{showColumnNames = TRUE} will
#' show the column names (i.e. sample names) on the heatmap. The default is
#' \code{TRUE}.
#' @param showRowNames logical. Setting \code{showColumnNames = TRUE} will
#' show the row names (i.e. plotting names) on the heatmap. The default is
#' \code{TRUE}.
#' @param colorSets a vector of names listing the color sets in the order
#' that they should be used in creating the heatmap. By default, this function
#' will use the color sets in the order listed in \code{Usage} for annotation
#' information. You may replace the default with the same collection of sets
#' in order that you want to use them, or provide custom color sets with the
#' \code{colList} parameter.
#' @param choose_color a vector of color names to be interpolated for the
#' heatmap gradient, or a \code{colorRamp} function produced by
#' \code{circlize::colorRamp2}. The default is \code{c("blue", "gray95", "red")}.
#' @param split_heatmap a character string either giving the column title of
#' \code{annotationplotting} containing annotation data for which to split
#' the heatmap rows, or \code{"none"} if no split is desired.
#' @param annotationplotting a \code{data.frame} or \code{matrix} with information
#' to be used
#' in splitting the heatmap. The first column should plotting names. The
#' column of annotation information should be specified in \code{split_heatmap.}
#' Other columns will be ignored. The default is \code{sigAnnotData}.
#' @param column_order a vector of character strings indicating the order in
#' which to manually arrange the heatmap columns. Default is \code{NULL},
#' such that column order is automatically determined via clustering.
#' @param ... Additional arguments to be passed to
#' \code{ComplexHeatmap::Heatmap()}.
#'
#' @return A ComplexHeatmap plot.
#' 
#' @author David Jenkins, Aubrey Odom
#' 
#'
#' @export
#'@examples
#' library(SummarizedExperiment)
#' # Example with a Summarized Experiment data object
#' dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
#' input_SE <- dat[["MicrobeGenetics"]]
#' 
#' ## Creating a continuous color ramp annot col list
#' Hairrange <- range(colData(input_SE)[, "HairLength"])
#' color2 <- circlize::colorRamp2(c(Hairrange[1], Hairrange[2]), c("blue", "red"))
#' color.list <- list("HairLength" = color2)
#' 
#' ## Create plot
#' plot_heatmap(
#'   inputData = input_SE,
#'   name = "Microbe abundances",
#'   plot_title = "Example Heatmap",
#'   plottingColNames = colnames(input_SE),
#'   annotationColNames = "HairLength",
#'   colList = color.list,
#'   scale = TRUE,
#'   showColumnNames = TRUE,
#'   showRowNames = FALSE,
#'   colorSets = 
#'     c("Set1", "Set2", "Set3", "Pastel1", "Pastel2", "Accent", "Dark2",
#'       "Paired"),
#'   choose_color = c("blue", "gray95", "red"),
#'   split_heatmap = "none",
#'   column_order = NULL
#' )
#' 
#' # Artificial data example - matrix input
#' mat_testdata <- rbind(matrix(c(rnorm(80), rnorm(80) + 5), 16, 10,
#'                              dimnames = list(paste0("Taxon", seq_len(16)),
#'                                              paste0("sample", seq_len(10)))),
#'                       matrix(rnorm(1000), 100, 10,
#'                              dimnames = list(paste0("Taxon0", seq_len(100)),
#'                                              paste0("sample", seq_len(10)))))
#' cov_mat <- data.frame(sample = c(rep("down", 5), rep("up", 5))) |>
#'   magrittr::set_rownames(paste0("sample", seq_len(10)))
#' 
#' # Example using custom colors for the annotation information
#' color2 <- stats::setNames(c("purple", "black"), c("down", "up"))
#' color.list <- list("sample" = color2)
#' 
#' plot_heatmap(
#'   inputData = mat_testdata,
#'   annotationData = cov_mat,
#'   name = "Data",
#'   plot_title = "Example",
#'   plottingColNames = NULL,
#'   annotationColNames = NULL,
#'   colList = color.list,
#'   scale = FALSE,
#'   showColumnNames = TRUE,
#'   showRowNames = FALSE,
#'   colorSets = c("Set1", "Set2", "Set3", "Pastel1", "Pastel2", "Accent", "Dark2",
#'                 "Paired"),
#'   choose_color = c("blue", "gray95", "red"),
#'   split_heatmap = "none",
#'   column_order = NULL
#' )
#'

# Plotting colnames should not be in colData...

plot_heatmap <- function(inputData, annotationData = NULL, plot_title = NULL,
                         name = "Input data",
                         plottingColNames,
                         annotationColNames = NULL,
                         colList = list(), scale = FALSE,
                         showColumnNames = TRUE,
                         showRowNames = TRUE, colorSets = c("Set1", "Set2",
                                                            "Set3", "Pastel1", "Pastel2", "Accent", "Dark2",
                                                            "Paired"),
                         choose_color = c("blue", "gray95", "red"),
                         split_heatmap = "none",
                         annotationplotting = NULL,
                         column_order = NULL,
                         ...) {
  # Ensure that ComplexHeatmap is installed
  if (!requireNamespace("ComplexHeatmap", quietly = TRUE)) {
    message("The 'ComplexHeatmap' package is not installed",
            "Please install it from CRAN to use this function.")
  }
  
  if (methods::is(inputData, "SummarizedExperiment")) {
    if (any(duplicated(plottingColNames))) {
      stop("Duplicate plotting column name is not supported.")
    }
    if (!all(plottingColNames %in% colnames(inputData))) {
      stop("Plotting column name(s) not found in inputData.")
    }
    if (!is.null(annotationColNames)) {
      if (!all(annotationColNames %in% colnames(SummarizedExperiment::colData(inputData)))) {
        stop("Annotation column name not found in inputData.")
      }
      annotationData <- SummarizedExperiment::colData(inputData)[, annotationColNames, drop = FALSE] %>%
        as.data.frame()
      inputData <- parse_MAE_SE(
        inputData, type = "SE")$counts[, plottingColNames, drop = FALSE]
    }
  } else {
    if (is.null(annotationData)) {
      stop("annotationData must be provided for a data.frame input object.")
    } else if (!is.null(annotationData)) {
      annotationColNames <- colnames(annotationData)
    }
  }
  if (nrow(annotationData) == nrow(inputData)) {
    if (!all(rownames(annotationData) == rownames(inputData))) {
      stop("Annotation data and plotting data does not match.")
    }
  } else if (nrow(annotationData) == ncol(inputData)) {
    if (!all(rownames(annotationData) == colnames(inputData))) {
      stop("Annotation data and plotting data does not match.")
    }
    # inputData <- t(inputData)
  } else {
    stop("Annotation data and plotting data does not match.")
  }
  # Transpose so sample names are on the columns
  sigresults <- inputData
  if (scale) {
    sigresults <- t(scale(t(sigresults)))
  }
  # To split heatmap by plotting annotation
  if (split_heatmap != "none") {
    if (!(split_heatmap %in% colnames(annotationplotting))) {
      stop("The column specified in 'split_heatmap' must be in the matrix or data.frame
           provided by 'annotationplotting'")
    }
  }
  ann_data <- annotationplotting[annotationplotting[, 1] %in%
                                   plottingColNames, ]
  if (split_heatmap == "none") {
    row_split_pass <- c()
  } else {
    row_split_pass <- ann_data[, split_heatmap]
  }
  if (length(colList) == 0) {
    colorSetNum <- 1
    for (annot in annotationColNames) {
      if (is.numeric(annotationData[, annot])) {
        t1min <- min(annotationData[, annot], na.rm = TRUE)
        t1max <- max(annotationData[, annot], na.rm = TRUE)
        if (requireNamespace("circlize", quietly = TRUE)) {
          colList[[annot]] <- circlize::colorRamp2(c(t1min, t1max),
                                                   c("white", "blue"))
        } else {
          message("The 'circlize' package is not installed",
                  "Please install it from CRAN to use this function.")
        }
      } else {
        if (is.factor(annotationData[, annot][!is.na(annotationData[, annot])])) {
          condLevels <- levels(annotationData[, annot][!is.na(annotationData[, annot])])
        } else {
          condLevels <- unique(annotationData[, annot][!is.na(annotationData[, annot])])
        }
        if (length(condLevels) > 8) {
          colors <- distinctColors(length(condLevels))
        } else {
          if (!requireNamespace("RColorBrewer", quietly = TRUE)) {
            message("The 'RColorBrewer' package is not installed",
                    "Please install it from CRAN to use this function.")
          }
          colors <- RColorBrewer::brewer.pal(8, colorSets[colorSetNum])
          colorSetNum <- colorSetNum + 1
        }
        colList[[annot]] <- stats::setNames(colors[seq_along(condLevels)],
                                            condLevels)
      }
    }
  }
  topha2 <- ComplexHeatmap::HeatmapAnnotation(
    df = data.frame(annotationData),
    col = colList, height = grid::unit(0.4 * length(annotationColNames), "cm"),
    show_legend = TRUE, show_annotation_name = TRUE)
  ComplexHeatmap::draw(
    ComplexHeatmap::Heatmap(sigresults, column_title = plot_title,
                            name = name,
                            show_column_names = showColumnNames,
                            col = choose_color,
                            show_row_names = showRowNames,
                            top_annotation = topha2,
                            row_split = row_split_pass,
                            column_order = column_order,
                            cluster_columns = TRUE, ...),
    annotation_legend_side = "bottom")
  return(NULL)
}

#' Create a formatted MultiAssayExperiment compatible with LegATo
#'
#' This function takes either a counts_dat, tax_dat, and metadata_dat input OR
#' a TreeSummarizedExperiment input and creates
#' a specifically-formatted MAE object that is compatible for use with LegATo
#' and animalcules. Checks are performed on inputs to ensure that they can be
#' integrated properly.
#'
#' @param counts_dat A matrix, data.table, or data.frame consisting of microbial
#'   raw counts data. The \code{colnames} should be sample names and the
#'   \code{rownames} should be in the same order as the \code{tax_dat} entries.
#'   Not required if \code{tree_SE} is passed in.
#' @param tax_dat A matrix, data.table, or data.frame of hierarchical taxonomic
#'   data. Should have columns such as "family", "genus", "species" with each
#'   row uniquely delineating a different taxon. The rows should be in the same
#'   order as the rows of \code{counts_dat}. Not required if \code{tree_SE} is
#'   passed in.
#' @param metadata_dat A metadata table with \code{rownames} equivalent to the
#'   samples that are the \code{colnames} of the \code{counts_dat}. Not required
#'   if \code{tree_SE} is passed in.
#' @param tree_SE A TreeSummarizedExperiment object with counts, taxonomy, and
#' metadata.
#'   
#' @export
#' @returns A \code{MultiAssayExperiment} object.
#' @examples
#' nsample <- ntaxa <- 3
#' counts_dat <- data.frame(
#'     "X123" = runif(ntaxa, 0, 500),
#'     "X456" = runif(ntaxa, 0, 500),
#'     "X789" = runif(ntaxa, 0, 500)
#' )
#' tax_dat <- data.frame(
#'     "class" = c("rand1", "rand2", "rand3"),
#'     "species" = c("rand4", "rand5", "rand6")
#' ) |>
#'     as.data.frame()
#' # Set rownames as lowest unique taxonomic level
#' rownames(tax_dat) <- tax_dat$species
#' rownames(counts_dat) <- tax_dat$species
#' metadata <- data.frame(
#'     Sample = c("X123", "X456", "X789"),
#'     Group = c("A", "B", "A"),
#'     Var = rnorm(nsample)
#' )
#' rownames(metadata) <- metadata$Sample
#' out_MAE <- create_formatted_MAE(counts_dat, tax_dat, metadata)
#' 
#' # TreeSummarizedExperiment
#' tse <- TreeSummarizedExperiment::TreeSummarizedExperiment(
#'     assays = list(counts = counts_dat),
#'     colData = metadata,            
#'     rowData = tax_dat             
#' )
#' out_MAE_2 <- create_formatted_MAE(tree_SE = tse)
#' out_MAE_2

create_formatted_MAE <- function(counts_dat = NULL, tax_dat = NULL, metadata_dat = NULL,
                                 tree_SE = NULL) {
    if (methods::is(tree_SE, "TreeSummarizedExperiment")) {
        counts_dat <- SummarizedExperiment::assays(tree_SE)[[1]]
        tax_dat <-SummarizedExperiment::rowData(tree_SE)
        metadata_dat <- SummarizedExperiment::colData(tree_SE) |> as.data.frame() 
    } else {
        if (is.null(counts_dat) | is.null(tax_dat) | is.null(metadata_dat)) {
            stop("Please supply counts, taxonomy, and metadata tables.")
        }
        to_check <- c("matrix", "data.table", "data.frame", "tibble")
        if (!(class(counts_dat) %in% to_check)) stop("counts_dat should be one of",
                                                 to_check)
        if (!(class(metadata_dat) %in% to_check)) stop("metadata_dat should be one of",
                                                   to_check)
        if (!(class(tax_dat) %in% to_check)) stop("tax_dat should be one of",
                                              to_check)
        if(nrow(tax_dat) != nrow(counts_dat)) stop(
            "The number of rows of tax_dat and counts_dat should be equal.")
        if(nrow(metadata_dat) != ncol(counts_dat)) stop(
            "The number of rows of metadata_dat and columns of counts_dat should be equal.")
    }
    
    se_mgx <- counts_dat %>% base::data.matrix() %>% S4Vectors::SimpleList() %>%
        magrittr::set_names("MGX")
    se_rowData <- tax_dat %>% base::data.frame() %>%
        dplyr::mutate_all(as.character) %>% S4Vectors::DataFrame()
    se_colData  <- metadata_dat %>% S4Vectors::DataFrame()
    
    microbe_se <- SummarizedExperiment::SummarizedExperiment(
        assays = se_mgx, colData = se_colData, rowData = se_rowData)
    MAE_out <- MultiAssayExperiment::MultiAssayExperiment(
        experiments = S4Vectors::SimpleList(MicrobeGenetics = microbe_se),
        colData = se_colData)
    
  return(MAE_out)
}

# If emmeans doesn't work, may need to step through function
mk_gee_plot <- function(this_coef, complex, tn, unit_var,
                        plotsave_loc, plot_terms, ...) {
  term_input <- unique(c(this_coef, plot_terms))
  if (!requireNamespace("ggeffects", quietly = TRUE) &&
      !requireNamespace("emmeans", quietly = TRUE)) {
    message("The 'ggeffects' and/or 'emmeans' packages are not installed",
            "Please install them from CRAN to use this function.")
  }
  p <- plot(ggeffects::ggemmeans(complex, terms = term_input)) + 
    ggplot2::labs(subtitle = "Estimated marginal means",
                  title = stringr::str_replace(tn, "_", " ")) +
    ggplot2::ylab("Taxon abundance (log CPM)") +
    ggplot2::theme_classic()
  filename <- file.path(plotsave_loc, paste0(tn, "_", this_coef, ".png"))
  ggplot2::ggsave(filename = filename, p, ...)
}

test_models_gee <- function(tn, input_df, unit_var, fixed_cov,
                            corstr, plot_out,
                            plotsave_loc, plot_terms, ...) {
    if (!requireNamespace("geepack", quietly = TRUE)) {
        message("The 'geepack' package is not installed",
                "Please install it from CRAN to use this function.")
    }
    filt_df <- input_df %>% 
        dplyr::mutate("unit_var" = as.factor(input_df[, unit_var])) %>%
        dplyr::filter(.data$taxon == tn) %>%
        dplyr::arrange(.data$unit_var) %>%
        dplyr::mutate(dplyr::across(dplyr::where(is.character),
                                    ~ as.factor(.)))
    group_vars <- paste("Abundance ~", paste(fixed_cov, collapse = " + ")) %>%
        stats::formula()
    complex <- geepack::geeglm(group_vars, id = unit_var, data = filt_df,
                               na.action = stats::na.omit, family = "gaussian",
                               corstr = corstr)
    if (requireNamespace("broom", quietly = TRUE) &&
        requireNamespace("broom.mixed", quietly = TRUE)) {
        sum_comp <- broom::tidy(complex, conf.int = TRUE)
    } else {
        message("The 'broom' and/or 'broom.mixed' packages are not installed",
                "Please install them to use this function.")
    }
    
    if (plot_out) {
        plyr::a_ply(fixed_cov, 1, mk_gee_plot, complex = complex, tn = tn,
                    plotsave_loc = plotsave_loc, plot_terms = plot_terms, ...)
    }
    res_out <- sum_comp %>%
        dplyr::mutate("Taxon" = tn) %>%
        dplyr::rename("Coefficient" = "term",
                      "Coefficient Estimate" = "estimate",
                      "Lower 95% CI" = "conf.low",
                      "Upper 95% CI" = "conf.high",
                      "Standard Error" = "std.error",
                      "Statistic" = "statistic",
                      "Pr(>|W|)" = "p.value") %>%
        as.data.frame()
    return(res_out)
}

#' Compute Generalized Estimating Equations (GEEs) on longitudinal microbiome
#' data
#'
#' This function takes an animalcules-formatted \code{MultiAssayExperiment} and
#' runs an independent GEE model for each taxon. The model predicts taxon log
#' CPM abundance as a product of fixed-effects covariates conditional on a
#' grouping ID variable, usually the unit on which repeated measurements were
#' taken. This modeling approach works best with small datasets that multiple
#' samples across many (>40) clusters/units. Note, the "broom", "ggeffects",
#' "broom.mixed", "geepack", "emmeans" packages are required to use this
#' function; all can be installed via CRAN.
#'
#' P-values are adjusted for the model coefficients within each taxon. The
#' following methods are permitted: \code{c("holm", "hochberg", "hommel",
#' "bonferroni", "BH", "BY", "fdr", "none")}
#'
#' @inheritParams test_hotelling_t2
#' @param unit_var A character string identifying the unit variable for which
#' there are multiple observations. Required.
#' @param fixed_cov A character vector naming covariates to be tested.
#' @param corstr A character string specifying the correlation structure. The
#'   following are permitted: '"independence"', '"exchangeable"', '"ar1"',
#'   '"unstructured"'.
#' @param p_adj_method A character string specifying the correction method. Can
#'   be abbreviated. See details. Default is \code{"fdr"}.
#' @param plot_out Logical indicating whether plots should be output alongside
#'   the model results. Default is \code{FALSE}.
#' @param plotsave_loc A character string giving the folder path to save plot
#'   outputs. This defaults to the current working directory.
#' @param plot_terms Character vector. Which terms should be examined in the
#'   plot output? Can overlap with the \code{fixed_cov} inputs.
#' @param ... Further arguments passed to \code{ggsave} for plot creation.
#'
#' @export
#' @importFrom rlang .data
#'
#' @returns A \code{data.frame} of modeling results.
#' @examples
#' in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |>
#'               readRDS()
#' out <- run_gee_model(in_dat, taxon_level = "genus", unit_var = "Subject",
#'                      fixed_cov = c("HairLength", "Age", "Group", "Sex"),
#'                      corstr = "ar1")
#' head(out)
#' 

run_gee_model <- function(dat,
                          taxon_level = "genus",
                          unit_var,
                          fixed_cov,
                          corstr = "ar1",
                          p_adj_method = "fdr",
                          plot_out = FALSE,
                          plotsave_loc = ".",
                          plot_terms = NULL,
                          ...) {
  input_df <- get_long_data(dat, taxon_level, log = TRUE, counts_to_CPM = TRUE)
  all_tn <- get_top_taxa(dat, taxon_level) %>% dplyr::pull("taxon")
  n <- length(all_tn)
  storage <- plyr::llply(all_tn, test_models_gee, input_df = input_df,
                         fixed_cov = fixed_cov,
                         unit_var = unit_var,
                         corstr = corstr,
                         plot_out = plot_out,
                         plotsave_loc = plotsave_loc,
                         plot_terms = plot_terms, ...) %>%
    data.table::rbindlist() %>%
    dplyr::arrange(.data$Coefficient) %>%
    dplyr::group_by(.data$Coefficient) %>%
    dplyr::mutate("Adj p-value" = stats::p.adjust(.data$`Pr(>|W|)`, method = p_adj_method)) %>%
    dplyr::rename("Unadj p-value" = .data$`Pr(>|W|)`) %>%
    as.data.frame()
  return(storage)
}

#' Clean up taxon names in a MultiAssayExperiment
#'
#' This functional is an optional method for fixing up taxon names in a
#' \code{MultiAssayExperiment} to be run before \code{filter_MAE}.
#' Specifically, it removes brackets from species names, replaces species labeled
#' as "others" with "sp." and finally replaces underscores with spaces.
#'
#' @inheritParams plot_stacked_bar
#' @inheritParams parse_MAE_SE
#'
#' @returns An animalcules-formatted \code{MultiAssayExperiment} object with
#'   cleaned-up taxonomy nomenclature.
#'
#' @export
#' @importFrom rlang .data
#'
#' @examples
#' in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
#' clean_MAE(in_dat)
#'

clean_MAE <- function(dat, which_experiment = NULL, which_assay = NULL) {
  # Extract data
  parsed <- parse_MAE_SE(dat, which_experiment = which_experiment,
                         which_assay = which_assay, type = "MAE")
  tax_table <- parsed$tax
  counts_table <- parsed$counts
  # Preliminary fixing of species names
  if(!all(c("genus", "species") %in% colnames(tax_table))) {
    stop("Columns 'genus' and 'species' must be present in taxonomy table.")
  } else if(!all.equal(rownames(tax_table), rownames(counts_table))) {
    stop("MAE could not be parsed correctly. Please ensure correct formatting.")
  }
  # Only need to alter species names in tax_table initially
  se_rowData  <- tax_table %>%
    dplyr::mutate("species" = stringr::str_remove_all(.data$species, "\\[|\\]"),
                  "species" = stringr::str_replace_all(.data$species, "_", " "))
  ## Replace species that are others with "sp."
  ind <- se_rowData$species == "others"
  se_rowData$species[ind] <- paste(se_rowData$genus[ind], "sp.", sep = " ")
  ## Replace genus that are others with species information
  ind <- se_rowData$genus == "others" & !is.na(se_rowData$genus)
  all_split <- plyr::aaply(strsplit(se_rowData$species, " "), 1,
                           function(x) x[[1]])
  se_rowData$genus[ind] <- all_split[ind]
  # Consolidate tax and counts to species level
  up_counts <- animalcules::upsample_counts(counts_table, se_rowData,
                                            higher_level = "species")
  up_rowData <- se_rowData %>%
    tibble::remove_rownames() %>%
    dplyr::distinct(.data$species, .keep_all = TRUE)
  ind <- match(rownames(up_counts), up_rowData$species)
  up_rowData <- up_rowData[ind, ]
  rownames(up_rowData) <- up_rowData$species
  
  MAE_out <- create_formatted_MAE(counts_dat = up_counts,
                                  tax_dat = up_rowData,
                                  metadata_dat = parsed$sam)
  return(MAE_out)
}

#' Create a long data.frame from a MultiAssayExperiment counts object
#'
#' This function takes a \code{MultiAssayExperiment} object and a specified
#' taxon level of interest and creates a long \code{data.frame} that can be used
#' more easily for plotting counts data.
#'
#' @inheritParams plot_stacked_bar
#' @param log logical. Indicate whether an assay returned should be the log of
#'   whichever assay is specified in \code{"output_name"}. If
#'   \code{counts_to_CPM = TRUE} as well, then a log CPM assay will also be
#'   created. Default is \code{FALSE}.
#' @param counts_to_CPM logical. This argument only applies if the
#'   \code{input_type} is a counts assay. If \code{TRUE}, then the output assays
#'   will include a normalized CPM assay. If \code{log = TRUE} as well, then a
#'   log CPM assay will also be created. Default is \code{TRUE}.
#'
#' @return A \code{data.frame} consisting of the counts data, taxa, and
#'   metadata.
#'
#' @export
#' @importFrom rlang .data
#'
#' @examples
#' in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
#' out <- get_long_data(in_dat, "genus", log = TRUE, counts_to_CPM = TRUE)
#' head(out)
#' 

get_long_data <- function(dat, taxon_level, log = FALSE,
                          counts_to_CPM = FALSE) {
  SE_obj <- dat[["MicrobeGenetics"]]
  assay_name <- names(SummarizedExperiment::assays(SE_obj))[1]
  which_assay <- assay_name
  if (log | counts_to_CPM) {
    # Check that TBSP is installed
    if (!requireNamespace("TBSignatureProfiler", quietly = TRUE)) {
      message("The 'TBSignatureProfiler' package is not installed",
              "Please install it from Bioconductor to use this function.")
    }
    SE_obj <- TBSignatureProfiler::mkAssay(SE_obj,
                                           input_name = assay_name,
                                           output_name = "assay",
                                           log = log, counts_to_CPM = counts_to_CPM)
    if (log) which_assay <- "log_assay"
    if (counts_to_CPM) which_assay <- "assay_cpm"
    if (log && counts_to_CPM) which_assay <- "log_assay_cpm"
  }
  
  microbe <- parse_MAE_SE(SE_obj, which_assay = which_assay, type = "SE")
  
  output <- animalcules::upsample_counts(microbe$counts, microbe$tax, taxon_level) %>%
    tibble::rownames_to_column("taxon") %>%
    tidyr::pivot_longer(cols = dplyr::all_of(colnames(microbe$counts)),
                        names_to = "Sample_id", values_to = "Abundance") %>%
    dplyr::left_join(tibble::rownames_to_column(microbe$sam, "Sample_id"),
                     by = "Sample_id") %>%
    dplyr::relocate("taxon", colnames(microbe$sam)) %>%
    as.data.frame()
  return(output)
}

#' Obtain a data.frame of ordered taxa abundances at a given level
#'
#' This function takes a \code{MultiAssayExperiment} object and returns a
#' data.frame of the present taxa at a user-supplied taxonomy level,
#' and outputs the average abundances of the taxa. 
#'
#' @inheritParams plot_stacked_bar
#'
#' @return A \code{data.frame}
#'
#' @export
#' @importFrom rlang .data
#'
#' @examples
#' in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
#' out <- get_top_taxa(in_dat, "genus")
#' out
#'

get_top_taxa <- function(dat, taxon_level = "genus") {
  microbe <- parse_MAE_SE(dat)
  all_relabu <- microbe$counts |>
    animalcules::upsample_counts(microbe$tax, taxon_level) %>%
    animalcules::counts_to_relabu() %>%
    tibble::rownames_to_column(var = "taxon") |>
    dplyr::rowwise("taxon") |>
    # Sum everything but the first columm (taxon name)
    dplyr::summarise(
      allmeans = mean(
        dplyr::c_across(dplyr::all_of(colnames(microbe$counts)))),
      .groups = "drop") |>
    dplyr::arrange(dplyr::desc(.data$allmeans)) |>
    as.data.frame()
  
  return(all_relabu)
}

---
title: "Extdata Explanations"
author: "Aubrey Odom"
date: "2024-01-06"
output: html_document
---

# Toy Data

`inst/extdata/MAE.RDS`

This file consists of a MultiAssayExperiment object with raw data published in the following paper:

Odom AR, Gill CJ, Pieciak R et al. Characterization of longitudinal nasopharyngeal microbiome patterns in maternally HIV-exposed Zambian infants [version 2; peer review: 2 approved with reservations]. Gates Open Res 2024, 6:143 (https://doi.org/10.12688/gatesopenres.14041.2)

The code to create the package data object is reproduced below.

```{R, eval = FALSE}
dat2 <- readRDS("/restricted/projectnb/infant-microbiome/work/aodom/HIV_Exposed_Infants/data/animalculesFinalHIV.rds")

# Add in pairing data
matched <- matrix(c("0554", "0469",
                    "0620", "0507",
                    "0645", "0539",
                    "0749", "0718",
                    "0798", "0801",
                    "0850", "0839",
                    "0895", "0878",
                    "0915", "0890",
                    "0987", "1040",
                    "1095", "1049"),
                  dimnames = list(c(), c("HIV", "Control")),
                  byrow = TRUE, ncol = 2) %>%
  tibble::as_tibble() %>%
  dplyr::mutate(pairing = seq_len(nrow(.))) %>%
  tidyr::pivot_longer(cols = c(HIV, Control), 
                      names_to = c("HIVStatus"),
                      values_to = "Subject") %>%
  dplyr::mutate(Subject = paste(Subject, "-1", sep = "")) 

# Merge with colData and extract SE objects
se_mgx <- SummarizedExperiment::assay(dat2, "MicrobeGenetics") %>%
  base::data.matrix() %>%
  S4Vectors::SimpleList() %>% magrittr::set_names("MGX")
se_colData <- SummarizedExperiment::colData(dat2[["MicrobeGenetics"]]) %>%
  as.data.frame() %>%
  tibble::rownames_to_column("rn") %>%
  dplyr::left_join(matched, by = c("Subject", "HIVStatus")) %>%
  as.data.frame() %>%
  tibble::column_to_rownames("rn") %>%
  S4Vectors::DataFrame()
se_rowData <- SummarizedExperiment::rowData(dat2[["MicrobeGenetics"]])

microbe_se <- SummarizedExperiment::SummarizedExperiment(
  assays = se_mgx, colData = se_colData, rowData = se_rowData)
MAE <- MultiAssayExperiment::MultiAssayExperiment(
  experiments = S4Vectors::SimpleList(MicrobeGenetics = microbe_se),
  colData = se_colData)

stem2 <- "/restricted/projectnb/infant-microbiome/work/aodom/LMTK/inst/extdata"
saveRDS(MAE, file.path(stem2, "MAE.RDS"))
```

This file is a small-form animalcules-formatted MAE object intended for usage with the examples.
```{R, eval = FALSE}
stem2 <- "/restricted/projectnb/infant-microbiome/work/aodom/LegATo/inst/extdata"

# Creating the sample data
which_sex <- sample(c("Male", "Female"), 10, replace = TRUE)
sample_table <- tibble(Sample = paste0("X-", seq_len(50)),
                       Subject = rep(paste0("S", seq_len(10)), 5),
                       Sex = rep(which_sex, 5),
                       Month = rep(seq_len(5), each = 10),
                       Group = rep(c("A", "B"), 25),
                       Pairing = rep(rep(seq_len(5), each = 2), 5)) %>%
  mutate("HairLength" = rnorm(50, mean = 50, sd = 14.5),
         "Age" = round(runif(50, 21, 80), 1)) %>%
  as.data.frame()
rownames(sample_table) <- sample_table$Sample

# Tax table
data_in_2 <- system.file("extdata/MAE.RDS", package = "LegATo") %>%
  readRDS() %>% filter_MAE(0.02)
tax_dat_pre <- parse_MAE_SE(data_in_2)$tax
ind <- sample(seq_len(nrow(tax_dat_pre)), 100)
tax_dat <- tax_dat_pre[ind, ] %>%
  arrange(species)

# Counts table
data_in <- system.file("extdata/MAE.rds", package = "animalcules") %>%
  readRDS()
counts_dat <- parse_MAE_SE(data_in)$counts
colnames(counts_dat) <- sample_table$Sample
rownames(counts_dat) <- rownames(tax_dat)

se_mgx <- counts_dat %>% base::data.matrix() %>% S4Vectors::SimpleList() %>%
  magrittr::set_names("MGX")
se_rowData <- tax_dat %>% base::data.frame() %>%
    dplyr::mutate_all(as.character) %>% S4Vectors::DataFrame()
se_colData  <- sample_table %>% S4Vectors::DataFrame()

write.csv(counts_dat, file.path(stem2, "counts.csv"))
write.csv(tax_dat, file.path(stem2, "tax.csv"))
write.csv(se_colData, file.path(stem2, "sample.csv"))

microbe_se <- SummarizedExperiment::SummarizedExperiment(
  assays = se_mgx, colData = se_colData, rowData = se_rowData)
MAE_out <- MultiAssayExperiment::MultiAssayExperiment(
  experiments = S4Vectors::SimpleList(MicrobeGenetics = microbe_se),
  colData = se_colData)

saveRDS(MAE_out, file.path(stem2, "MAE_small.RDS"))
```

---
title: "LegATo Tutorial"
author: 
- name: Aubrey R. Odom
  affiliation: 
  - Program in Bioinformatics, Boston University, Boston, MA
  email: aodom@bu.edu
date: '`r format(Sys.Date(), "%B %e, %Y")`'
package: LegATo
output: html_document
vignette: >
  %\VignetteIndexEntry{LegATo Tutorial}
  %\VignetteEncoding{UTF-8}
  %\VignetteEngine{knitr::rmarkdown}
editor_options: 
  chunk_output_type: console
---

# Introduction to LegATo

## Streamlining longitudinal microbiome profiling in Bioconductor

Microbiome time-series data presents several distinct challenges, including complex covariate dependencies and a variety of longitudinal study designs. Furthermore, while several individual tools have been created to aid in longitudinal microbiome data analysis, an all-inclusive R-based toolkit has remained elusive. 

To address these concerns, we have created LegATo (Longitudinal mEtaGenomic Analysis TOolkit). LegATo is a suite of open-source software tools for longitudinal microbiome analysis that is extendable to several different study forms, all while promising optimal ease-of-use for researchers.  This toolkit will allow researchers to determine which microbial taxa are affected over time by perturbations such as onset of disease or lifestyle choices, and to predict the effects of these perturbations over time, including changes in composition or stability of commensal bacteria.

Currently, LegATo entertains a number of data cleaning, aggregation, modeling and testing procedures. As we develop or learn of new methods, we will add to the toolkit accordingly. We will soon add hierarchical clustering tools and multivariate generalized estimating equations (JGEEs) to adjust for the compositional nature of microbiome data.

# Getting started with LegATo

## Compatibility with `MultiAssayExperiment` and `SummarizedExperiment` objects

The convenience of LegATo is in part credited to the integration of `MultiAssayExperiment` and `SummarizedExperiment` objects. These are reliable and clean data structures developed by the \emph{Bioconductor team} as part of the `r BiocStyle::Biocpkg("MultiAssayExperiment")` and `r BiocStyle::Biocpkg("SummarizedExperiment")` packages.

The `MultiAssayExperiment` container concisely stores a `SummarizedExperiment` object, which aggregates data matrices along with annotation information, metadata, and reduced dimensionality data (PCA, t-SNE, etc.). To learn more about proper usage and context of these objects, you may want to take a look at the [MultiAssayExperiment package vignette](https://bioconductor.org/packages/release/bioc/vignettes/MultiAssayExperiment/inst/doc/MultiAssayExperiment.html) and [SummarizedExperiment package vignette](https://bioconductor.org/packages/release/bioc/vignettes/SummarizedExperiment/inst/doc/SummarizedExperiment.html).

To install these two packages, run the following code:
```{r MAE_SE_install, eval = FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("MultiAssayExperiment")
BiocManager::install("SummarizedExperiment")
```

## Installation and setup

To install the development version of LegATo from Github, run the following code:

```{r load_LegATo, eval = FALSE}
BiocManager::install("wejlab/LegATo")
```

Now we'll load the LegATo package into our library:
```{R}
library(LegATo)
```

For the purposes of this vignette, we'll also load the `ggeffects` and `emmeans` library:
```{R}
library(ggeffects)
library(emmeans)
```

# Formatting input data for use with LegATo

LegATo functions expect data properly formatted in a `MultiAssayExperiment` container, with naming conventions that are compatible with `r BiocStyle::Biocpkg("animalcules")`. Obtaining properly formatted data can be achieved easily via the `create_formatted_MAE()` function from the LegATo package, as detailed below.

## A note on compatibility with other packages

If you've analyzed your metagenomic or 16S data via the [MetaScope package](https://wejlab.github.io/metascope-docs/), you can aggregate your sample outputs with user-input metadata using the `MetaScope::convert_animalcules()` or `MetaScope::convert_animalcules_silva()` functions prior to loading your data into LegATo. These functions create a taxonomy table and collate all data into a LegATo- and animalcules-compatible `MultiAssayExperiment` object.

You can also format your data analyzed elsewhere (e.g., PathoScope 2.0 or Kraken) with the [animalcules package](https://wejlab.github.io/animalcules-docs/) in the upload step with the R Shiny app, and then select "Download Animalcules File" to obtain a `MAE` object that can be used with LegATo.

## Requirements for using `create_formatted_MAE()`

For the purposes of this example, we'll look at some example inputs unrelated to the main HIV-E infant data:

* The `counts` table is composed of raw microbial counts. There is one row for each taxon, and one column for each sample.
* The `tax` table is composed of taxonomy lineages. There is one row for each taxon, and any number of columns each taxonomic level (e.g., superkingdom, genus, species). The lowest level of taxonomy serves as the rownames for the table, and is also stored in its own column. Taxonomic levels increase in granularity from left to right.
* The `sample` table contains entries for each sample, with unique sample IDs on the rows. The columns are metadata for the samples, such as subjects or units on which repeated measures were taken, groupings, pairings, and covariates.
* `rownames(counts) == rownames(tax)`
* `colnames(counts) == colnames(sample)`

```{R}
counts <- system.file("extdata", "counts.csv", package = "LegATo") |>
  read.csv(row.names = 1) |>
  dplyr::rename_with(function(x) stringr::str_replace(x, "\\.", "-"))
tax <- system.file("extdata", "tax.csv", package = "LegATo") |> read.csv(row.names = 1)
sample <- system.file("extdata", "sample.csv", package = "LegATo") |> read.csv(row.names = 1)
```

Now we'll look at the formatting of each:
```{R}
ndim <- 5
counts[seq_len(ndim), seq_len(ndim)] |>
  knitr::kable(caption = "Counts Table Preview",
               label = NA)

tax[seq_len(ndim), ] |>
  knitr::kable(caption = "Taxonomy Table Preview",
               label = NA)

sample[seq_len(ndim), ] |>
  knitr::kable(caption = "Sample Table Preview",
               label = NA)
```

## Formatting your inputs with `create_formatted_MAE()`

Once your data are formatted correctly, you can easily use `create_formatted_MAE()` like so:
```{R}
output <- create_formatted_MAE(counts_dat = counts,
                               tax_dat = tax,
                               metadata_dat = sample)

class(output)
MultiAssayExperiment::assays(output)
SummarizedExperiment::assays(output[["MicrobeGenetics"]])
```

If your data is in the format of a TreeSummarizedExperiment, you can call `create_formatted_MAE(tree_SE)` to create a `MAE` output that is compatible with the package.

## Adding information to your metadata later in your analysis

If information needs to be added to your data object at some later point in the analysis, it is easiest to manipulate the raw data objects (potentially via `parse_MAE_SE()`) and then recreate the `MAE` object with `create_formatted_MAE()`.

# Example data

To illustrate the capabilities of LegATo, we will turn to a published dataset from the following paper:

Odom AR, Gill CJ, Pieciak R et al. Characterization of longitudinal nasopharyngeal microbiome patterns in maternally HIV-exposed Zambian infants [version 2; peer review: 2 approved with reservations]. Gates Open Res 2024, 6:143 (https://doi.org/10.12688/gatesopenres.14041.2)

The raw dataset is archived in Zenodo:

*Zenodo: Underlying data for ‘Characterization of longitudinal nasopharyngeal microbiome patterns in maternally HIV-exposed Zambian infants’. https://doi.org/10.5281/zenodo.725531324*

Further details on how the dataset was altered for inclusion in this package are provided [here](https://github.com/wejlab/LegATo/blob/main/inst/script/extdata_explanations.Rmd).

### Example data context and structure

The example data consists of 167 NP swabs of healthy HIV-exposed, uninfected (HEU; n=10) infants and their HIV(+) mothers and HIV-unexposed, uninfected (HUU; n=10) infants and their HIV(-) mothers. A total of 7 samples were collected per infant, with some missingness in the data. These swabs were identified from a sample library collected in Lusaka, Zambia between 2015 and 2016. 

The analysis objective is to parse the association between the NP resident bacteria and infant HIV exposure during the first 3.5 months (14 weeks) of life, a critical time in microbiome maturation.

All data was processed with `PathoScope 2.0`, and the sample outputs were aggregated with the `animalcules` R package.

For this analysis, we will work with the infant data only and subset the data accordingly.

```{R}
dat <- system.file("extdata", "MAE.RDS", package = "LegATo") |>
  readRDS()

dat_subsetted <- MultiAssayExperiment::subsetByColData(dat,
                                                       dat$MothChild == "Infant")
```

This leaves us with `r dim(parse_MAE_SE(dat_subsetted)$sam)[1]` samples in our analysis.

# Initial data exploration

## `MultiAssayExperiment (MAE)` manipulation

`LegATo` has several functions for manipulating `MAE` objects, delineated below:

### Clean up animalcules-formatted `MAE`s

If your data were aggregated via the `animalcules` package, as was done for the example data, the samples were aggregated at the strain taxonomic level and have residual taxonomy IDs present. The `clean_MAE()` function cleans up data suffering from these issues.

```{R}
dat_cleaned <- clean_MAE(dat_subsetted)
```

### Filter MAE

Many metagenomic pipelines identify taxon abundances at extremely small levels, which can be noisy to deal with in an analysis. The `filter_MAE` function smoothly transforms reads belonging to taxa with an overall genera threshold under the `filter_prop` (filter proportion) argument, which we will set as 0.005.

```{R}
dat_filt_1 <- filter_MAE(dat_cleaned, relabu_threshold = 0.05, occur_pct_cutoff = 10)
```

The `filter_animalcules_MAE` function utilizes the same filtering mechanism as in the animalcules package:

```{R}
dat_filt <- filter_animalcules_MAE(dat_cleaned, 0.05)
```

### Parse MAE to extract data

If you want to take a closer look at your data, you can easily extract it into the counts, taxonomy, and sample metadata tables using the `parse_MAE_SE()` function.

```{R}
parsed <- parse_MAE_SE(dat_filt, type = "MAE")

parsed$counts[seq_len(5), seq_len(5)] |> 
  knitr::kable(caption = "Counts Table")

parsed$sam[seq_len(5), ]  |>
  knitr::kable(caption = "Sample Metadata")

parsed$tax[seq_len(5), ] |> 
  knitr::kable(caption = "Taxonomy Table")

```

### Summarizing microbial counts data

It is fairly convenient to summarize the average number of reads for a report with `get_summary_table()`. The table groups by user-provided discrete covariates.
```{R}
group_vars <- c("HIVStatus", "MothChild")
get_summary_table(dat_filt, group_vars) |>
  knitr::kable(caption = "Summary Table", label = NA)
```

The `get_top_taxa` function outputs a `data.frame` that lists taxa in order of relative abundance.
```{R}
best_genus <- get_top_taxa(dat_filt, "genus")
best_genus |> knitr::kable(caption = "Table of genera, ranked by abundance")
```

### Other data manipulation functions

If you want to conduct your own analyses, the `get_long_data()` function will prove convenient. The `get_stacked_data()` function can be used for certain visualizations that utilize a relative abundance aggregation approach.

```{R}
longdat <- get_long_data(dat_filt, "genus", log = TRUE, counts_to_CPM = TRUE)

stackeddat <- get_stacked_data(dat_filt, "genus", covariate_1 = "HIVStatus",
                               covariate_time = "timepoint")
```

## Visualizing Data

There are several plots by which we can visualize changes in relative abundance over time, accounting for a given covariate. In this case, we are interested in HIV exposure.

We'll select a palette using `paletteer`.
```{R}
this_palette <- c("#709AE1", "#8A9197", "#D2AF81", "#FD7446", "#D5E4A2", "#197EC0", "#F05C3B", "#46732E",
                  "#71D0F5", "#370335", "#075149", "#C80813", "#91331F", "#1A9993", "#FD8CC1") |>
  magrittr::extract(seq_len(nrow(best_genus)))
```

### Alluvial plots

Alluvial diagrams illustrate individual taxa as stream fields that change position at different time points. The height of a stream field represents the relative abundance of that taxon. At a given time point, stream fields are ranked from the highest to lowest abundance (top to bottom). These can be constructed with `plot_alluvial()`.
```{R}
plot_alluvial(dat = dat_filt, 
              taxon_level = "genus", 
              covariate_1 = "HIVStatus",
              covariate_time = "timepoint",
              palette_input = this_palette,
              subtitle = "Alluvial plot")
```

In context, this plot indicates a high abundance of Staphylococcus in both the control and HIV-E infants in the first two weeks of life, but other genera quickly overtake **Staphylococcus** in dominance as shown by the changing rank of the streams for each time point. Overall, **Streptococcus** seems to have a far greater presence in the HIV-E infants' nasopharyngeal microbiota

### Spaghetti plots

We can create spaghetti or volatility plots to elucidate changes over time on a sample level for a given taxon. This is advantageous as other visualization methods are often aggregates of multiple samples and lack granularity. These plots can be created with `plot_spaghetti()`.

```{R, results = "asis", message = FALSE}
  plot_spaghetti(dat = dat_filt,
               covariate_time = "timepoint",
               covariate_1 = "HIVStatus",
               unit_var = "Subject",
               taxon_level = "genus",
               which_taxon = "Staphylococcus",
               palette_input = this_palette,
               title = "Spaghetti Plot",
               subtitle = NULL) +
  ggplot2::xlab("Infant Age (timepoint)") +
  ggplot2::ylab("Relative Abundance (log CPM)")
```

Here we plot changes in the **Staphylococcus** log counts per million (CPM) across time points. The spaghetti plot format clues us into the few outlier infants in the control group that seem to have extremely high counts in the first few weeks of life.

### Stacked bar plots

Stacked bar plots are used here to visualize the relative abundance of microbes at a given taxonomic level in each sample, represented as a single bar, labeled by time point, and plotted within each HIV exposure status group for separate mothers and infant comparisons. Use `plot_stacked_bar`.
```{R}
plot_stacked_bar(dat_filt, "genus", 
             "HIVStatus",
             "timepoint",
             palette_input = this_palette)
```

We see from the stacked bar plots that many of the microbes seem to maintain similar trends in both control and HIV-E infants over time, with **Streptococcus** producing slightly higher abundances in the HIV-E group.

### Stacked area charts

Stacked area charts are similar to stacked bar plots, but provide for continuity between time points. These are created with `plot_stacked_area()`.  

```{R}
plot_stacked_area(dat_filt, "genus", 
                  "HIVStatus",
                  "timepoint",
                  palette_input = this_palette)
```

The stacked area chart is offers a similar method of visualizing the data.

### Heatmaps

With `plot_heatmap`, you can plot a heatmap of a specific microbe to determine changes along one or more covariates. 

```{R}
this_taxon <- parsed$counts |>
  animalcules::upsample_counts(parsed$tax, "genus") |>
  animalcules::counts_to_logcpm()
p <- plot_heatmap(inputData = this_taxon,
                  annotationData = dplyr::select(parsed$sam, "timepoint", "HIVStatus", "pairing"),
                  name = "Data",
                  plot_title = "Example",
                  plottingColNames = NULL,
                  annotationColNames = NULL,
                  colList = list(),
                  scale = FALSE,
                  showColumnNames = FALSE,
                  showRowNames = FALSE,
                  colorSets = c("Set1", "Set2", "Set3", "Pastel1", "Pastel2", "Accent", "Dark2",
                                "Paired"),
                  choose_color = c("blue", "gray95", "red"),
                  split_heatmap = "none",
                  column_order = NULL
)
```

From the heatmap, we find that clustering does not seem to find a clear relationship between genera (on the rows) and samples (on the columns). Three annotations were plotted on the top bar: time point, HIV status, and pairing.

# Longitudinal data analysis

For a concrete analysis of longitudinal microbiome data, `LegATo` provides NMIT, both a paired and unpaired multivariate Hotelling's T-squared test, generalized estimating equations (GEEs) and linear mixed effects models (LMEMs/LMMs).

A brief overview of each method is provided below.

## Nonparametric microbial interdependence test (NMIT)

NMIT is a multivariate distance-based test intended to evaluate the association between key phenotypic variables and microbial interdependence. The test determines longitudinal sample similarity as a function of temporal microbial composition. 
  
The authors thank Yilong Zhang for providing his code for adaptation into LegATo.
  
Citations:

Yilong Zhang, Sung Won Han, Laura M Cox, and Huilin Li. A multivariate distance-based analytic framework for microbial interdependence association test in longitudinal study. Genetic epidemiology, 41(8):769–778, 2017. doi:10.1002/gepi.22065.
```{R}
dat_1 <- filter_MAE(dat_cleaned, 0.05, 10, "species")

NMIT(dat_1, unit_var = "Subject", fixed_cov = "HIVStatus",
     covariate_time = "timepoint",
     method = "kendall", dist_type = "F",
     heatmap = TRUE, classify = FALSE, fill_na = 0)
```

## Hotelling's T^2 Test

Hotelling’s T2 tests can be used to determine whether the microbiome profiles exhibit notable differences or trends across time and groups. We may then use t-tests to identify which genera contributed most to these differences.

For this example, HEU and HUU infants are designated as the two sampling units on which the relative abundances of the p most abundant genera will be measured. 

For paired tests, we chose p = 6 variables to ensure that n < p so that singularity could be avoided and T2 could be properly computed, where n is the number of measurements in a sampling unit. Normality is met by using microbe abundances in log CPM units, which is calculated within the function.

```{R}
test_hotelling_t2(dat = dat_1,
                  test_index = which(dat_filt$MothChild == "Infant" &
                                       dat_filt$timepoint == 6),
                  taxon_level = "genus",
                  num_taxa = 6,
                  paired = TRUE,
                  grouping_var = "HIVStatus",
                  pairing_var = "pairing")
```

Group comparisons can also be tested on unpaired data:
```{R}
test_hotelling_t2(dat = dat_1,
                  test_index = which(dat_filt$timepoint == 0),
                  taxon_level = "genus",
                  num_taxa = 6,
                  grouping_var = "HIVStatus",
                  unit_var = "Subject",
                  paired = FALSE)

```

## Modeling

### Generalized Estimating Equations (GEEs)

Generalized estimating equations (GEEs) as described in Liang and Zeger (1986) and extended by Agresti (2002) have been widely used for modeling longitudinal data, and more recently for longitudinal microbiome data.

For each genus present in the microbial aggregate of samples, we model normalized log CPM relative taxon counts, estimating the effects of time point and HIV exposure status and their interaction, while accounting for the underlying structure of clusters formed by individual subjects. 

```{R}
output <- run_gee_model(dat_1, unit_var = "Subject",
                        fixed_cov = c("HIVStatus", "timepoint"),
                        corstr = "ar1",
                        plot_out = FALSE,
                        plotsave_loc = ".",
                        plot_terms = NULL)

head(output) |> knitr::kable(caption = "GEE Outputs")
```

You can also create plots of the covariates, which will be saved to a folder specified by the user:

```{R, out.width = "50%", fig.align = "center", echo = FALSE}
tempfolder <- tempdir()

# Trying out plotting
output <- run_gee_model(dat_1, unit_var = "Subject",
              taxon_level = "genus",
              fixed_cov = c("HIVStatus", "timepoint"),
              corstr = "ar1",
              plot_out = TRUE,
              plotsave_loc = tempfolder,
              plot_terms = "timepoint",
              width = 6, height = 4, units = "in", scale = 0.7)

list.files(tempfolder) |> head()
```

### Linear Mixed Models

Similarly, you can also run linear mixed-effects models:
```{R}
# If there are issues with matrix being positive definite
# Revisit filtering parameters in filter_MAE
output <- run_lmm_model(dat_1, unit_var = "Subject",
                        taxon_level = "genus",
                        fixed_cov = c("timepoint", "HIVStatus"),
                        plot_out = FALSE,
                        plotsave_loc = ".",
                        plot_terms = NULL)

head(output) |> knitr::kable(caption = "LMM Outputs")
```

# Session Info

```{R}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/clean_MAE.R
\name{clean_MAE}
\alias{clean_MAE}
\title{Clean up taxon names in a MultiAssayExperiment}
\usage{
clean_MAE(dat, which_experiment = NULL, which_assay = NULL)
}
\arguments{
\item{dat}{A \code{MultiAssayExperiment} object specially formatted as an
animalcules output.}

\item{which_experiment}{Character string. If \code{type = "MAE"}, then
this is the name of the experiment to be accessed. If \code{NULL},
will default to the first available experiment.}

\item{which_assay}{Character string. Regardless of whether 
\code{type = "MAE"} or \code{"SE"}, this is the name of the selected
\code{SummarizedExperiment} object. If \code{NULL}, defaults to first listed.}
}
\value{
An animalcules-formatted \code{MultiAssayExperiment} object with
  cleaned-up taxonomy nomenclature.
}
\description{
This functional is an optional method for fixing up taxon names in a
\code{MultiAssayExperiment} to be run before \code{filter_MAE}.
Specifically, it removes brackets from species names, replaces species labeled
as "others" with "sp." and finally replaces underscores with spaces.
}
\examples{
in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
clean_MAE(in_dat)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NMIT.R
\name{tscor}
\alias{tscor}
\title{Calculate within-subject OTU correlations}
\usage{
tscor(dat, unit_var, method = "kendall", fill_na = 0)
}
\arguments{
\item{dat}{A \code{MultiAssayExperiment} object specially formatted as an
animalcules output.}

\item{unit_var}{a numeric vector of subject.}

\item{method}{an option of the correlation method ("pearson", "kendall",
"spearman"). The default method is "kendall".}

\item{fill_na}{a number between 0 and 1 to fill the missing value. The
default value is 0.}
}
\value{
An three-dimensional array of temporal correlation matrices for each
  subject.
}
\description{
This function takes a \code{MultiAssayExperiment} and outputs an array of
temporal intra-subject correlation matrices.
}
\examples{
dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
output <- tscor(dat, unit_var = "Subject", method = "spearman")
head(output)

}
\author{
Yilong Zhang, Huilin Li, Aubrey Odom
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_spaghetti.R
\name{plot_spaghetti}
\alias{plot_spaghetti}
\title{Plot a spaghetti volatility plot of microbial abundance for a given taxon}
\usage{
plot_spaghetti(
  dat,
  covariate_time,
  covariate_1 = NULL,
  unit_var,
  taxon_level,
  which_taxon,
  palette_input = NULL,
  title = "Spaghetti Plot",
  subtitle = NULL
)
}
\arguments{
\item{dat}{A \code{MultiAssayExperiment} object specially formatted as an
animalcules output.}

\item{covariate_time}{Character string giving the name of the discrete
time-based covariate in the metadata to group abundances by.}

\item{covariate_1}{Character string, the name of the covariate in `dat`
by which to color and group samples. Default is \code{NULL}.}

\item{unit_var}{Character string, the name of the column delineating the
unit on which the microbial abundances are changing over time. This is
likely something akin to a subject that repeated measurements are made on.}

\item{taxon_level}{Character string indicating the level of taxonomy to
aggregate the counts data. Must be the name of a column in
\code{MultiAssayExperiment::rowData(dat)}.}

\item{which_taxon}{Character string, the name of the taxon to plot at the
specified taxon level.}

\item{palette_input}{A character vector of colors that is at minimum the same
length of the number of taxa (specified with \code{taxon_level}).
The default is \code{NULL} and relies on \code{ggplot2}'s default scheme.}

\item{title}{A character string providing the plot title.}

\item{subtitle}{A character string providing the plot subtitle. The default
is \code{NULL}.}
}
\value{
A \code{ggplot2} plot.
}
\description{
This function takes a \code{MultiAssayExperiment} object and returns a
spaghetti plot of microbial abundance delineated by a unit, such as
a subject.
}
\details{
If further manipulation of specific parameters is desired, users can add
\code{ggplot2} function calls to the output of the function.
}
\examples{
in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
all_taxa <- get_top_taxa(in_dat, "phylum")
plot_spaghetti(in_dat, taxon_level = "phylum", covariate_1 = "Group", covariate_time = "Month",
              unit_var = "Subject", which_taxon = all_taxa$taxon[1],
              palette_input = rainbow(25))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/filter_animalcules_MAE.R
\name{filter_animalcules_MAE}
\alias{filter_animalcules_MAE}
\title{Filter a MultiAssayExperiment to a top percentage of taxa and label the rest
as "Other"}
\usage{
filter_animalcules_MAE(dat, filter_prop = 0.001)
}
\arguments{
\item{dat}{A \code{MultiAssayExperiment} object specially formatted as an
animalcules output.}

\item{filter_prop}{A double strictly between 0 and 1, representing
the proportion of relative abundance at which to filter. Default is 0.001.}
}
\value{
An animalcules-formatted \code{MultiAssayExperiment} object with
  appropriate filtration.
}
\description{
This function takes an animalcules-formatted \code{MultiAssayExperiment}
(MAE) object and identifies all taxa at the "genus" level that represent
<\code{filter_prop} average relative abundance across all samples in the MAE.
After identification at the genus level, taxa across the genus and species
levels are then consolidated into the category "Other".
}
\examples{
in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
filter_animalcules_MAE(in_dat, 0.01)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/test_hotelling_t2.R
\name{test_hotelling_t2}
\alias{test_hotelling_t2}
\title{Conduct a multivariate Hotelling's T-squared test}
\usage{
test_hotelling_t2(
  dat,
  test_index = NULL,
  taxon_level = "genus",
  num_taxa,
  grouping_var,
  paired = FALSE,
  pairing_var = NULL,
  unit_var = NULL,
  save_table_loc = "."
)
}
\arguments{
\item{dat}{A MultiAssayExperiment object specially formatted as an animalcules output.}

\item{test_index}{Any argument used for subsetting the input \code{dat},
can be a character, logical, integer, list or List vector. Default is \code{NULL}.}

\item{taxon_level}{Character string, default is \code{"genus"}.}

\item{num_taxa}{The number of most abundant taxa to test. If unpaired, this should
be no larger than the total number of subjects in both groups - 2, or (n1 + n2 -2).
If paired, this should be no larger than the total number of pairs - 1, or n - 1.
Required.}

\item{grouping_var}{Character string, the name of a DICHOTOMOUS grouping variable in the
metadata of \code{dat}.}

\item{paired}{Logical indicating whether a paired test should be conducted.
Default is \code{FALSE} for an unpaired test.}

\item{pairing_var}{Character string giving the variable containing pairing information.
The variable should be in integer form. Must be supplied if \code{paired = TRUE},
otherwise the default is NULL.}

\item{unit_var}{Character string giving the variable containing the identifiers
for the unit on which multiple measurements were conducted, e.g. subjects. Default is
\code{NULL}; must be supplied if \code{paired = FALSE}.}

\item{save_table_loc}{A character string giving the folder path to save t.test results.
Note that these are only conducted if the Hotelling's T-test value is <0.05. 
Defaults to the current working directory.}
}
\value{
A list of the elements "df1", "df2", "crit_F", "F_stat" and "pvalue" giving the
results of the test.
}
\description{
This function takes an animalcules-formatted \code{MultiAssayExperiment}
object and runs a multivariate Hotelling's T-squared test. The test expects
a comparison of two distinct groups, and compares the abundances of the top microbes at a
given taxon level between the groups. This function allows both paired and unpaired
tests. Both test the null hypothesis that the population
mean vectors are equal, with the alternative being that they are unequal.
}
\details{
The Hotelling's t-squared statistic (t2) is a generalization of
Student's t-statistic that is used in multivariate hypothesis testing
to test the means of different populations.

Note that any entries or pairs with missing values are excluded.

Referenced articles in the implementation of tests:

https://online.stat.psu.edu/stat505/lesson/7/7.1/7.1.14

https://online.stat.psu.edu/stat505/lesson/7/7.1/7.1.15

https://online.stat.psu.edu/stat505/lesson/7/7.1/7.1.4

https://online.stat.psu.edu/stat505/lesson/7/7.1/7.1.9
}
\examples{
dat <- system.file("extdata", "MAE.RDS", package = "LegATo") |>
readRDS()
dat_0.05 <- filter_MAE(dat, 0.001, 10, "species")
out1 <- test_hotelling_t2(dat = dat_0.05,
                  test_index = which(dat_0.05$MothChild == "Infant" &
                                       dat_0.05$timepoint == 0),
                  taxon_level = "genus",
                  # Total number of pairs - 1
                  num_taxa = 9,
                  paired = TRUE,
                  grouping_var = "HIVStatus",
                  pairing_var = "pairing")
out1                  

out <- test_hotelling_t2(dat = dat_0.05,
                  test_index = which(dat_0.05$MothChild == "Mother" &
                                       dat_0.05$timepoint == 6),
                  taxon_level = "genus",
                  # Max is Total number of subjects - 2
                  # Here we use a much smaller number
                  num_taxa = 6,
                  grouping_var = "HIVStatus",
                  unit_var = "Subject",
                  paired = FALSE)
out                  

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/run_lm_model.R
\name{run_lm_model}
\alias{run_lm_model}
\title{Compute linear models (LM) on microbiome data}
\usage{
run_lm_model(
  dat,
  taxon_level = "genus",
  fixed_cov,
  p_adj_method = "fdr",
  plot_out = FALSE,
  plotsave_loc = ".",
  plot_terms = NULL,
  ...
)
}
\arguments{
\item{dat}{A MultiAssayExperiment object specially formatted as an animalcules output.}

\item{taxon_level}{Character string, default is \code{"genus"}.}

\item{fixed_cov}{A character vector naming covariates to be tested.}

\item{p_adj_method}{A character string specifying the correction method. Can
be abbreviated. See details. Default is \code{"fdr"}.}

\item{plot_out}{Logical indicating whether plots should be output alongside
the model results. Default is \code{FALSE}.}

\item{plotsave_loc}{A character string giving the folder path to save plot
outputs. This defaults to the current working directory.}

\item{plot_terms}{Character vector. Which terms should be examined in the
plot output? Can overlap with the \code{fixed_cov} inputs.}

\item{...}{Further arguments passed to \code{ggsave} for plot creation.}
}
\value{
A \code{data.frame} of modeling results.
}
\description{
This function takes an animalcules-formatted \code{MultiAssayExperiment} and
runs an independent linear model for each taxon. The model predicts taxon log
CPM abundance as a product of user-specified covariates. This model can
be used for general microbiome analyses without repeated measures data.
Note, the "broom", and
"broom.mixed" packages are required to use the testing functionality of this
package; both can be installed via CRAN.
}
\details{
P-values are adjusted for the model coefficients within each taxon. The
following methods are permitted: \code{c("holm", "hochberg", "hommel",
"bonferroni", "BH", "BY", "fdr", "none")}
}
\examples{
dat <- system.file("extdata/MAE.RDS", package = "LegATo") |>
  readRDS() |>
  filter_MAE()
out <- run_lm_model(dat, fixed_cov = c("timepoint", "HIVStatus"),
                    plot_out = FALSE)
head(out)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_top_taxa.R
\name{get_top_taxa}
\alias{get_top_taxa}
\title{Obtain a data.frame of ordered taxa abundances at a given level}
\usage{
get_top_taxa(dat, taxon_level = "genus")
}
\arguments{
\item{dat}{A \code{MultiAssayExperiment} object specially formatted as an
animalcules output.}

\item{taxon_level}{Character string indicating the level of taxonomy to
aggregate the counts data. Must be the name of a column in
\code{MultiAssayExperiment::rowData(dat)}.}
}
\value{
A \code{data.frame}
}
\description{
This function takes a \code{MultiAssayExperiment} object and returns a
data.frame of the present taxa at a user-supplied taxonomy level,
and outputs the average abundances of the taxa.
}
\examples{
in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
out <- get_top_taxa(in_dat, "genus")
out

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_long_data.R
\name{get_long_data}
\alias{get_long_data}
\title{Create a long data.frame from a MultiAssayExperiment counts object}
\usage{
get_long_data(dat, taxon_level, log = FALSE, counts_to_CPM = FALSE)
}
\arguments{
\item{dat}{A \code{MultiAssayExperiment} object specially formatted as an
animalcules output.}

\item{taxon_level}{Character string indicating the level of taxonomy to
aggregate the counts data. Must be the name of a column in
\code{MultiAssayExperiment::rowData(dat)}.}

\item{log}{logical. Indicate whether an assay returned should be the log of
whichever assay is specified in \code{"output_name"}. If
\code{counts_to_CPM = TRUE} as well, then a log CPM assay will also be
created. Default is \code{FALSE}.}

\item{counts_to_CPM}{logical. This argument only applies if the
\code{input_type} is a counts assay. If \code{TRUE}, then the output assays
will include a normalized CPM assay. If \code{log = TRUE} as well, then a
log CPM assay will also be created. Default is \code{TRUE}.}
}
\value{
A \code{data.frame} consisting of the counts data, taxa, and
  metadata.
}
\description{
This function takes a \code{MultiAssayExperiment} object and a specified
taxon level of interest and creates a long \code{data.frame} that can be used
more easily for plotting counts data.
}
\examples{
in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
out <- get_long_data(in_dat, "genus", log = TRUE, counts_to_CPM = TRUE)
head(out)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_stacked_data.R
\name{get_stacked_data}
\alias{get_stacked_data}
\title{Create a long data.frame with grouped abundances from a MultiAssayExperiment counts object}
\usage{
get_stacked_data(dat, taxon_level = "genus", covariate_1, covariate_time)
}
\arguments{
\item{dat}{A \code{MultiAssayExperiment} object specially formatted as an
animalcules output.}

\item{taxon_level}{Character string indicating the level of taxonomy to
aggregate the counts data. Must be the name of a column in
\code{MultiAssayExperiment::rowData(dat)}.}

\item{covariate_1}{Character string, the name of the covariate in `dat`
by which to color and group samples. Default is \code{NULL}.}

\item{covariate_time}{Character string giving the name of the discrete
time-based covariate in the metadata to group abundances by.}
}
\value{
A \code{data.frame} consisting of the counts data, taxa, and metadata.
}
\description{
This function takes a \code{MultiAssayExperiment} object and a specified
taxon level of interest and creates a long \code{data.frame} that can be used
more easily for plotting counts data in a stacked bar plot or a stacked area
chart. The function groups taxa and computes relative abundance within taxa strata.
}
\examples{
in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
get_stacked_data(in_dat, "genus", covariate_1 = "Sex", covariate_time = "Month")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LegATo-package.R
\docType{package}
\name{LegATo-package}
\alias{LegATo}
\alias{LegATo-package}
\title{LegATo: LegATo: Longitudinal mEtaGenomic Analysis Toolkit}
\description{
LegATo is a suite of open-source software tools for longitudinal microbiome analysis. It is extendable to several different study forms with optimal ease-of-use for researchers. Microbiome time-series data presents distinct challenges including complex covariate dependencies and variety of longitudinal study designs. This toolkit will allow researchers to determine which microbial taxa are affected over time by perturbations such as onset of disease or lifestyle choices, and to predict the effects of these perturbations over time, including changes in composition or stability of commensal bacteria.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://wejlab.github.io/LegATo-docs/}
  \item Report bugs at \url{https://github.com/wejlab/LegATo/issues}
}

}
\author{
\strong{Maintainer}: Aubrey Odom \email{aodom@bu.edu} (\href{https://orcid.org/0000-0001-7113-7598}{ORCID})

Other contributors:
\itemize{
  \item Yilong Zhang \email{elong0527@gmail.com} (Author of NMIT functions) [contributor]
  \item Jared Pincus \email{pincus@bu.edu} (\href{https://orcid.org/0000-0001-6708-5262}{ORCID}) (Naming consultant of package) [consultant]
  \item Jordan Pincus \email{pincus@bu.edu} (Artist of LegATo icon) [artist]
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_stacked_area.R
\name{plot_stacked_area}
\alias{plot_stacked_area}
\title{Plot a stacked area chart of microbial relative abundance}
\usage{
plot_stacked_area(
  dat,
  taxon_level,
  covariate_1 = NULL,
  covariate_time,
  palette_input = NULL,
  title = paste("Relative abundance at", taxon_level, "level"),
  subtitle = NULL
)
}
\arguments{
\item{dat}{A \code{MultiAssayExperiment} object specially formatted as an
animalcules output.}

\item{taxon_level}{Character string indicating the level of taxonomy to
aggregate the counts data. Must be the name of a column in
\code{MultiAssayExperiment::rowData(dat)}.}

\item{covariate_1}{Character string giving the name of a column in
\code{MultiAssayExperiment::colData(dat)} on which to create multiple
plots. The default is \code{NULL}.}

\item{covariate_time}{Character string giving the name of the discrete
time-based covariate in the metadata to group abundances by.}

\item{palette_input}{A character vector of colors that is at minimum the same
length of the number of taxa (specified with \code{taxon_level}).
The default is \code{NULL} and relies on \code{ggplot2}'s default scheme.}

\item{title}{A character string providing the plot title.}

\item{subtitle}{A character string providing the plot subtitle. The default
is \code{NULL}.}
}
\value{
A \code{ggplot2} plot.
}
\description{
This function takes a \code{MultiAssayExperiment} object and returns a
stacked area chart of microbe relative abundances. The function takes a single
covariate as an optional variable by which to create a grid of multiple
plots.
}
\details{
If further manipulation of specific parameters is desired, users can add
\code{ggplot2} function calls to the output of the function.
}
\examples{
in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
plot_stacked_area(in_dat, taxon_level = "phylum", covariate_1 = "Group",
                  covariate_time = "Month",
                  palette_input = rainbow(25))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_heatmap.R
\name{plot_heatmap}
\alias{plot_heatmap}
\title{Plot a ComplexHeatmap.}
\usage{
plot_heatmap(
  inputData,
  annotationData = NULL,
  plot_title = NULL,
  name = "Input data",
  plottingColNames,
  annotationColNames = NULL,
  colList = list(),
  scale = FALSE,
  showColumnNames = TRUE,
  showRowNames = TRUE,
  colorSets = c("Set1", "Set2", "Set3", "Pastel1", "Pastel2", "Accent", "Dark2",
    "Paired"),
  choose_color = c("blue", "gray95", "red"),
  split_heatmap = "none",
  annotationplotting = NULL,
  column_order = NULL,
  ...
)
}
\arguments{
\item{inputData}{an input data object. It should either be of the class
\code{SummarizedExperiment} and contain the data and
annotation data as columns in the colData, or alternatively be of the classes
\code{data.frame} or \code{matrix} and contain only the plotting data.
Required.}

\item{annotationData}{a \code{data.frame} or \code{matrix} of annotation
data, with one column. Only required if \code{inputData} is a
\code{data.frame} or \code{matrix} of plotting data.
The row names must equal those of the \code{inputData} column names.
Default is \code{NULL}.}

\item{plot_title}{a character string with the plot title of the heatmap. The
default is \code{NULL}.}

\item{name}{a character string with the name of the data to be displayed.
Default is \code{"Input data"}.}

\item{plottingColNames}{a vector of the column names in \code{colData} that
contain the plotting data. Only required if \code{inputData} is a
SummarizedExperiment object.}

\item{annotationColNames}{a vector of the column names in \code{colData} that
contain the annotation data. Only required if \code{inputData} is a
\code{SummarizedExperiment}. Default is \code{NULL}.}

\item{colList}{a named \code{list} of named vectors specifying custom color
information to
pass to \code{ComplexHeatmap::Heatmap()}. The list should have as many
elements as there are annotation columns, and each element name should
correspond exactly with the name of each annotation column.
The colors in the vector elements should be named according to the
levels of the factor in that column's annotation data if the annotation
is discrete, or it should be produced with \code{circlize::colorRamp2}
if the annotation is continuous.
By default, \code{ColorBrewer} color sets will be used.
See the the parameter \code{colorSets} for additional details.}

\item{scale}{logical. Setting \code{scale = TRUE} scales the plotting data.
The default is \code{FALSE}.}

\item{showColumnNames}{logical. Setting \code{showColumnNames = TRUE} will
show the column names (i.e. sample names) on the heatmap. The default is
\code{TRUE}.}

\item{showRowNames}{logical. Setting \code{showColumnNames = TRUE} will
show the row names (i.e. plotting names) on the heatmap. The default is
\code{TRUE}.}

\item{colorSets}{a vector of names listing the color sets in the order
that they should be used in creating the heatmap. By default, this function
will use the color sets in the order listed in \code{Usage} for annotation
information. You may replace the default with the same collection of sets
in order that you want to use them, or provide custom color sets with the
\code{colList} parameter.}

\item{choose_color}{a vector of color names to be interpolated for the
heatmap gradient, or a \code{colorRamp} function produced by
\code{circlize::colorRamp2}. The default is \code{c("blue", "gray95", "red")}.}

\item{split_heatmap}{a character string either giving the column title of
\code{annotationplotting} containing annotation data for which to split
the heatmap rows, or \code{"none"} if no split is desired.}

\item{annotationplotting}{a \code{data.frame} or \code{matrix} with information
to be used
in splitting the heatmap. The first column should plotting names. The
column of annotation information should be specified in \code{split_heatmap.}
Other columns will be ignored. The default is \code{sigAnnotData}.}

\item{column_order}{a vector of character strings indicating the order in
which to manually arrange the heatmap columns. Default is \code{NULL},
such that column order is automatically determined via clustering.}

\item{...}{Additional arguments to be passed to
\code{ComplexHeatmap::Heatmap()}.}
}
\value{
A ComplexHeatmap plot.
}
\description{
This function takes an arbitrary dataset as an input and returns a
\code{ComplexHeatmap} plot of samples based on similarity of microbial
abundances. The function takes arguments listed here as well
as any others to be passed on to \code{ComplexHeatmap::Heatmap()}. Note, the
"circlize" and "ComplexHeatmap" packages are required to use this function.
}
\details{
If both \code{annotationData = NULL} and \code{annotationColNames = NULL},
no annotation bar will be drawn on the heatmap.

Code was adapted from the \code{TBSignatureprofiler} R package.
}
\examples{
library(SummarizedExperiment)
# Example with a Summarized Experiment data object
dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
input_SE <- dat[["MicrobeGenetics"]]

## Creating a continuous color ramp annot col list
Hairrange <- range(colData(input_SE)[, "HairLength"])
color2 <- circlize::colorRamp2(c(Hairrange[1], Hairrange[2]), c("blue", "red"))
color.list <- list("HairLength" = color2)

## Create plot
plot_heatmap(
  inputData = input_SE,
  name = "Microbe abundances",
  plot_title = "Example Heatmap",
  plottingColNames = colnames(input_SE),
  annotationColNames = "HairLength",
  colList = color.list,
  scale = TRUE,
  showColumnNames = TRUE,
  showRowNames = FALSE,
  colorSets = 
    c("Set1", "Set2", "Set3", "Pastel1", "Pastel2", "Accent", "Dark2",
      "Paired"),
  choose_color = c("blue", "gray95", "red"),
  split_heatmap = "none",
  column_order = NULL
)

# Artificial data example - matrix input
mat_testdata <- rbind(matrix(c(rnorm(80), rnorm(80) + 5), 16, 10,
                             dimnames = list(paste0("Taxon", seq_len(16)),
                                             paste0("sample", seq_len(10)))),
                      matrix(rnorm(1000), 100, 10,
                             dimnames = list(paste0("Taxon0", seq_len(100)),
                                             paste0("sample", seq_len(10)))))
cov_mat <- data.frame(sample = c(rep("down", 5), rep("up", 5))) |>
  magrittr::set_rownames(paste0("sample", seq_len(10)))

# Example using custom colors for the annotation information
color2 <- stats::setNames(c("purple", "black"), c("down", "up"))
color.list <- list("sample" = color2)

plot_heatmap(
  inputData = mat_testdata,
  annotationData = cov_mat,
  name = "Data",
  plot_title = "Example",
  plottingColNames = NULL,
  annotationColNames = NULL,
  colList = color.list,
  scale = FALSE,
  showColumnNames = TRUE,
  showRowNames = FALSE,
  colorSets = c("Set1", "Set2", "Set3", "Pastel1", "Pastel2", "Accent", "Dark2",
                "Paired"),
  choose_color = c("blue", "gray95", "red"),
  split_heatmap = "none",
  column_order = NULL
)

}
\author{
David Jenkins, Aubrey Odom
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_summary_table.R
\name{get_summary_table}
\alias{get_summary_table}
\title{Create a table summarizing reads aggregated by grouping variables on a unit}
\usage{
get_summary_table(dat, group_vars = NULL)
}
\arguments{
\item{dat}{A \code{MultiAssayExperiment} object specially formatted as an
animalcules output.}

\item{group_vars}{A character string or character vector of covariates
found in \code{colData(dat)} to use in grouping counts. The variables
should be listed in order of desired grouping. Default is \code{NULL},
which does not rely on a grouping variable and instead produces statistics
for the entirety of the data.}
}
\value{
A \code{data.frame} of the grouping columns, mean_reads, sd_reads,
min_reads, max_reads and num_total.
}
\description{
This function takes a \code{MultiAssayExperiment} of microbial read counts
and aggregates them by one or more grouping vars within a unit.
}
\examples{
in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
out <- get_summary_table(in_dat, c("Group", "Subject"))
head(out)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/parse_MAE_SE.R
\name{parse_MAE_SE}
\alias{parse_MAE_SE}
\title{Parse a MultiExperimentAssay object and extract the elements as data.frames}
\usage{
parse_MAE_SE(dat, which_experiment = NULL, which_assay = NULL, type = "MAE")
}
\arguments{
\item{dat}{Either a \code{MultiAssayExperiment} or a
\code{SummarizedExperiment} object.}

\item{which_experiment}{Character string. If \code{type = "MAE"}, then
this is the name of the experiment to be accessed. If \code{NULL},
will default to the first available experiment.}

\item{which_assay}{Character string. Regardless of whether 
\code{type = "MAE"} or \code{"SE"}, this is the name of the selected
\code{SummarizedExperiment} object. If \code{NULL}, defaults to first listed.}

\item{type}{One of "MAE" denoting a \code{MultiAssayExperiment} or "SE"
denoting a \code{SummarizedExperiment}.}
}
\value{
Returns a list of 3 named data.frame elements, `counts`, `sam`, and
  `tax` denoting the counts data, sample metadata table, and taxonomy table,
  respectively.
}
\description{
This function takes an animalcules-formatted \code{MultiAssayExperiment}
object and parses it to extract a named assay alongside the taxonomy and
metadata.
}
\examples{
in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
out <- parse_MAE_SE(in_dat)
head(out$tax)
head(out$sam)
head(out$counts)

out2 <- parse_MAE_SE(in_dat[["MicrobeGenetics"]],
                     which_assay = "MGX", type = "SE")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/filter_MAE.R
\name{filter_MAE}
\alias{filter_MAE}
\title{Filter a MultiAssayExperiment object to keep a top percentage of taxa}
\usage{
filter_MAE(
  dat,
  relabu_threshold = 3,
  occur_pct_cutoff = 5,
  taxon_level = "genus"
)
}
\arguments{
\item{dat}{A \code{MultiAssayExperiment} object specially formatted as an
animalcules output.}

\item{relabu_threshold}{A double(percentage) between 0 and 100, representing
the relative abundance criterion that all OTUs should meet to be retained.
The smaller the threshold, the fewer the OTUs will be retained. Default is
3\%.}

\item{occur_pct_cutoff}{A double (percentage) between 0 and 100
representing the percent cutoff for how many OTUs must meet the
\code{relabu_threshold} across the samples to be retained. It is wise to
keep the number of samples in mind when setting this parameter. Default is 5\%.}

\item{taxon_level}{Character string indicating the level of taxonomy to
aggregate the counts data. Must be the name of a column in
\code{MultiAssayExperiment::rowData(dat)}.}
}
\value{
An animalcules-formatted \code{MultiAssayExperiment} object
with major OTUs retained.
}
\description{
This function takes an animalcules-formatted \code{MultiAssayExperiment} (MAE)
object and identifies all taxa at the OTU level of choice that exhibit a
relative abundance greater than or equal to a relative abundance percent
threshold, \code{relabu_threshold}, in at least \code{occur_pct_cutoff}\% of
the total samples. After filtration, taxa across the specified OTU level and
all downstream levels are then consolidated into the category "Other".
}
\examples{
  in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |>
    readRDS()
  filter_MAE(in_dat, relabu_threshold = 3, occur_pct_cutoff = 5,
             taxon_level = "genus")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/run_gee_model.R
\name{run_gee_model}
\alias{run_gee_model}
\title{Compute Generalized Estimating Equations (GEEs) on longitudinal microbiome
data}
\usage{
run_gee_model(
  dat,
  taxon_level = "genus",
  unit_var,
  fixed_cov,
  corstr = "ar1",
  p_adj_method = "fdr",
  plot_out = FALSE,
  plotsave_loc = ".",
  plot_terms = NULL,
  ...
)
}
\arguments{
\item{dat}{A MultiAssayExperiment object specially formatted as an animalcules output.}

\item{taxon_level}{Character string, default is \code{"genus"}.}

\item{unit_var}{A character string identifying the unit variable for which
there are multiple observations. Required.}

\item{fixed_cov}{A character vector naming covariates to be tested.}

\item{corstr}{A character string specifying the correlation structure. The
following are permitted: '"independence"', '"exchangeable"', '"ar1"',
'"unstructured"'.}

\item{p_adj_method}{A character string specifying the correction method. Can
be abbreviated. See details. Default is \code{"fdr"}.}

\item{plot_out}{Logical indicating whether plots should be output alongside
the model results. Default is \code{FALSE}.}

\item{plotsave_loc}{A character string giving the folder path to save plot
outputs. This defaults to the current working directory.}

\item{plot_terms}{Character vector. Which terms should be examined in the
plot output? Can overlap with the \code{fixed_cov} inputs.}

\item{...}{Further arguments passed to \code{ggsave} for plot creation.}
}
\value{
A \code{data.frame} of modeling results.
}
\description{
This function takes an animalcules-formatted \code{MultiAssayExperiment} and
runs an independent GEE model for each taxon. The model predicts taxon log
CPM abundance as a product of fixed-effects covariates conditional on a
grouping ID variable, usually the unit on which repeated measurements were
taken. This modeling approach works best with small datasets that multiple
samples across many (>40) clusters/units. Note, the "broom", "ggeffects",
"broom.mixed", "geepack", "emmeans" packages are required to use this
function; all can be installed via CRAN.
}
\details{
P-values are adjusted for the model coefficients within each taxon. The
following methods are permitted: \code{c("holm", "hochberg", "hommel",
"bonferroni", "BH", "BY", "fdr", "none")}
}
\examples{
in_dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |>
              readRDS()
out <- run_gee_model(in_dat, taxon_level = "genus", unit_var = "Subject",
                     fixed_cov = c("HairLength", "Age", "Group", "Sex"),
                     corstr = "ar1")
head(out)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_heatmap.R
\name{distinctColors}
\alias{distinctColors}
\title{Generate a distinct palette for coloring different clusters.}
\usage{
distinctColors(
  n,
  hues = c("red", "cyan", "orange", "blue", "yellow", "purple", "green", "magenta"),
  saturation.range = c(0.7, 1),
  value.range = c(0.7, 1)
)
}
\arguments{
\item{n}{an integer describing the number of colors to generate. Required.}

\item{hues}{a vector of character strings indicating the R colors available
from the \code{colors()} function. These will be used as the base colors for
the clustering scheme. Different saturations and values (i.e. darkness)
will be generated for each hue. Default is \code{c("red", "cyan", "orange",
"blue", "yellow", "purple", "green", "magenta")}}

\item{saturation.range}{a numeric vector of length 2 with values between 0
and 1 giving the range of saturation. The default is \code{c(0.25, 1)}.}

\item{value.range}{a numeric vector of length 2 with values between 0 and 1
giving the range of values. The default is \code{c(0.5, 1)}.}
}
\value{
A vector of distinct colors that have been converted to HEX from
HSV.
}
\description{
Create a distinct palette for coloring different heatmap clusters. The
function returns colors for input into \code{ComplexHeatmap:Heatmap()}.
The "grDevices" package is required to use this function.
}
\examples{

distinctColors(10)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_formatted_MAE.R
\name{create_formatted_MAE}
\alias{create_formatted_MAE}
\title{Create a formatted MultiAssayExperiment compatible with LegATo}
\usage{
create_formatted_MAE(
  counts_dat = NULL,
  tax_dat = NULL,
  metadata_dat = NULL,
  tree_SE = NULL
)
}
\arguments{
\item{counts_dat}{A matrix, data.table, or data.frame consisting of microbial
raw counts data. The \code{colnames} should be sample names and the
\code{rownames} should be in the same order as the \code{tax_dat} entries.
Not required if \code{tree_SE} is passed in.}

\item{tax_dat}{A matrix, data.table, or data.frame of hierarchical taxonomic
data. Should have columns such as "family", "genus", "species" with each
row uniquely delineating a different taxon. The rows should be in the same
order as the rows of \code{counts_dat}. Not required if \code{tree_SE} is
passed in.}

\item{metadata_dat}{A metadata table with \code{rownames} equivalent to the
samples that are the \code{colnames} of the \code{counts_dat}. Not required
if \code{tree_SE} is passed in.}

\item{tree_SE}{A TreeSummarizedExperiment object with counts, taxonomy, and
metadata.}
}
\value{
A \code{MultiAssayExperiment} object.
}
\description{
This function takes either a counts_dat, tax_dat, and metadata_dat input OR
a TreeSummarizedExperiment input and creates
a specifically-formatted MAE object that is compatible for use with LegATo
and animalcules. Checks are performed on inputs to ensure that they can be
integrated properly.
}
\examples{
nsample <- ntaxa <- 3
counts_dat <- data.frame(
    "X123" = runif(ntaxa, 0, 500),
    "X456" = runif(ntaxa, 0, 500),
    "X789" = runif(ntaxa, 0, 500)
)
tax_dat <- data.frame(
    "class" = c("rand1", "rand2", "rand3"),
    "species" = c("rand4", "rand5", "rand6")
) |>
    as.data.frame()
# Set rownames as lowest unique taxonomic level
rownames(tax_dat) <- tax_dat$species
rownames(counts_dat) <- tax_dat$species
metadata <- data.frame(
    Sample = c("X123", "X456", "X789"),
    Group = c("A", "B", "A"),
    Var = rnorm(nsample)
)
rownames(metadata) <- metadata$Sample
out_MAE <- create_formatted_MAE(counts_dat, tax_dat, metadata)

# TreeSummarizedExperiment
tse <- TreeSummarizedExperiment::TreeSummarizedExperiment(
    assays = list(counts = counts_dat),
    colData = metadata,            
    rowData = tax_dat             
)
out_MAE_2 <- create_formatted_MAE(tree_SE = tse)
out_MAE_2
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NMIT.R
\name{NMIT}
\alias{NMIT}
\title{Nonparametric Microbial Interdependence Test (NMIT)}
\usage{
NMIT(
  dat,
  unit_var,
  fixed_cov,
  covariate_time,
  method = "kendall",
  dist_type = "F",
  heatmap = TRUE,
  classify = FALSE,
  fill_na = 0,
  ...
)
}
\arguments{
\item{dat}{A \code{MultiAssayExperiment} object specially formatted as an
animalcules output.}

\item{unit_var}{a numeric vector of subject.}

\item{fixed_cov}{A character vector of the names of covariates of interest found in
\code{dat}.}

\item{covariate_time}{Character string giving the name of the discrete
time-based covariate in the metadata to group abundances by.}

\item{method}{an option of the correlation method ("pearson", "kendall",
"spearman"). The default method is "kendall".}

\item{dist_type}{A character string specifying the type of matrix norm to be
computed. The default is \code{"F"}.
* \code{"M"} or \code{"m"} specifies the maximum modulus of all the
  elements in \code{x};
* \code{"O"}, \code{"o"} or \code{"1"} specifies the one norm,
  (maximum absolute column sum);
* \code{"I"} or \code{"i"} specifies the infinity norm (maximum
  absolute row sum);
* \code{"F"} or \code{"f"} specifies the Frobenius norm (the
  Euclidean norm of \code{x} treated as if it were a vector)}

\item{heatmap}{A logical value indicating whether to draw heatmap. The
default is \code{TRUE}.}

\item{classify}{A logical value indicating whether to draw a classifier tree.
The default is \code{FALSE}.}

\item{fill_na}{A number between 0 and 1 to fill \code{NA} values. The default
value is 0.}

\item{...}{Additional arguments to be passed to \code{ComplexHeatmap::Heatmap()}.}
}
\value{
This function returns an analysis of variance (ANOVA) table showing
  sources of variation, degrees of freedom, sequential sums of squares, mean
  squares, F statistics, partial R-squared and P values, based on 999
  permutations.
}
\description{
An R-based implementation of the NMIT, a multivariate distance-based test for
group comparisons of microbial temporal interdependence. The NMIT test
provides a comprehensive way to evaluate the association between key
phenotypic variables and microbial interdependence. This function is
recommended for use after a filtering step using
\code{filter_MAE}. Note, the "ComplexHeatmap" package is required to
use the plotting features of the function. The function requires the
"vegan" package.
}
\examples{
dat <- system.file("extdata/MAE_small.RDS", package = "LegATo") |> readRDS()
NMIT(dat, unit_var = "Subject", fixed_cov = "Group", covariate_time = "Month")

}
\author{
Yilong Zhang, Huilin Li, Aubrey Odom
}
